<?php

class berichte{

private $datei;
private $daten;
private $gleinst;

public function __construct($gleinst){
	$this->datei = PFAD_INCLUDE.'conf/berichte.xml';
	$this->gleinst = $gleinst;
	$this->einlesen();
}

public function holeTitel(){
	$rueckgabe = [];
	foreach($this->daten as $id => $bericht){
		$rueckgabe[$id] = $bericht['titel'];
	}
	return $rueckgabe;
}

public function holeBerichte(){
	return $this->daten;
}

private function einlesen(){

	$berichte = new SimpleXMLElement($this->datei, 0, true);

	$this->daten = [];
	foreach($berichte as $bericht){
		$id = (string)$bericht['id'];

		$eintrag = [
			'titel'     => (string)$bericht->titel,
			'spalten'   => explode(';', $bericht->spalten),
			'query'     => trim(str_replace('DB_PREFIX', DB_PREFIX, $bericht->query)),
			'verlinken' => (isset($bericht['verlinken']) and $bericht['verlinken']==1)?1:0
		];

		if(isset($bericht['gleinstellung'])){
			# je nach globalen Einstellungen ggf. ausblenden
			$einst = explode(';', $bericht['gleinstellung']);
			$wert = $this->gleinst[$einst[0]][$einst[1]];
			if($wert != $einst[2]){
				continue;
			}
			$eintrag['gleinstellung'] = explode(';', $bericht['gleinstellung']);
		}
		
		$this->daten[$id] = $eintrag;
	}
}

} # Ende der Klasse, EOF
