<?php

class stundennachweise {

var $user;
var $datenpfad;
var $dateiname;
var $datei;
var $daten;
var $kal;
var $db;
var $datengeaendert = false;

function __construct(){
	$this->user = $_SESSION['user']['id'];
	$this->datenpfad = PFAD_INIDATEIEN;
	$this->dateiname = 'stundennachweis_'.$this->user.'.ini';
	$this->datei = $this->datenpfad.$this->dateiname;
	$this->leseDaten();
}

function holeHalbjahre($art='vorhandene',$htmloptions=false){
/* Werte fuer $art:
 - vorhandene (Standard): gib die vorhandenen aus
 - fehlende: gibt die fehlenden aus*
 - alle: gibt alle Halbjahre aus* + ggf. schon vorhande

*alle sind jeweils die beiden Halbjahre des aktuellen und des naechsten und des letzten Jahres
*/
	$daten = array();
	switch($art){
	case 'alle':
		$halbjahre = array_keys($this->daten);
		foreach($halbjahre as $h){
			$tmp = array();
			list($tmp['j'],$tmp['h']) = explode('_',$h,2);
			$daten[$h] = $tmp;
		}
		$jahr = date('Y');
		$daten[($jahr-1).'_1'] = array('h'=>1, 'j'=>$jahr-1);
		$daten[($jahr-1).'_2'] = array('h'=>2, 'j'=>$jahr-1);
		$daten[$jahr.'_1']     = array('h'=>1, 'j'=>$jahr);
		$daten[$jahr.'_2']     = array('h'=>2, 'j'=>$jahr);
		$daten[($jahr+1).'_1'] = array('h'=>1, 'j'=>$jahr+1);
		$daten[($jahr+1).'_2'] = array('h'=>2, 'j'=>$jahr+1);
		ksort($daten);
		break;
	case 'fehlende':
		$jahr = date('Y');
		$daten[($jahr-1).'_1'] = array('h'=>1, 'j'=>$jahr-1);
		$daten[($jahr-1).'_2'] = array('h'=>2, 'j'=>$jahr-1);
		$daten[$jahr.'_1']     = array('h'=>1, 'j'=>$jahr);
		$daten[$jahr.'_2']     = array('h'=>2, 'j'=>$jahr);
		$daten[($jahr+1).'_1'] = array('h'=>1, 'j'=>$jahr+1);
		$daten[($jahr+1).'_2'] = array('h'=>2, 'j'=>$jahr+1);
		$halbjahre = array_keys($this->daten);
		foreach($halbjahre as $h){
			if(isset($daten[$h])){
				unset($daten[$h]);
			}
		}
		ksort($daten);
		break;
	case 'vorhanden':
	default:
		$halbjahre = array_keys($this->daten);
		foreach($halbjahre as $h){
			$tmp = array();
			list($tmp['j'],$tmp['h']) = explode('_',$h,2);
			$daten[$h] = $tmp;
		}
		ksort($daten);
		break;
	}
	if($htmloptions){
		foreach($daten as $key => $halbj){
			$daten[$key] = $halbj['h'].'. Halbjahr '.$halbj['j'];
		}
	}
	return $daten;
}

function loescheHalbjahr($key){
	if(!isset($this->daten[$key])){
		return -1;
	}
	unset($this->daten[$key]);
	$this->datengeaendert = true;
	$this->schreibeDaten();
	return true;
}

function legeNeuesHalbjahrAn($halbjahr,$jahr){
	# allgemeine Einstellungen holen
	global $_einst;
	$conf = $_einst['stundennachweis'];
	$key = $jahr.'_'.$halbjahr;
	if(!ctype_digit($jahr) or $jahr < 2000 or $jahr > 2100){
		return -1; # Jahr ungültig
	}
	if($halbjahr != 1 and $halbjahr != 2){
		return -1; # Halbjahr ungültig
	}
	if(isset($this->daten[$key])){
		return -2; # Datensatz existiert bereits
	}

	# Trainingstage
	require_once(PFAD_INCLUDE.'class/kalender.inc.php');
	$this->kal = new kalender;
	$this->kal->db = &$this->db;

	# Trainingstage des Trainers holen
	$query = "SELECT z.wochentag, TIME_FORMAT(z.von,'%H:%i') as anfang, TIME_FORMAT(z.bis,'%H:%i') as ende
				FROM (".DB_PREFIX."gruppen as g LEFT JOIN ".DB_PREFIX."gruppen_uebungsleiter as gu ON g.id=gu.gruppenid) 
				  LEFT JOIN ".DB_PREFIX."trainingszeiten as z ON g.id=z.gruppenid
				WHERE gu.uebungsleiterid = ".$_SESSION['user']['id']." AND bezeichnung NOT LIKE '%Trainingslager%'
				ORDER BY z.wochentag, z.von";
	$this->db->holeDaten($query);
	$stunden = $this->db->baueArray('*','#');
	# Termine pro Woche zusammenbauen
	$tmp = array(
		'wtag'   => -1,
		'anfang' => '00:00',
		'ende'   => '',
		'gruppen' => 1
	);
	$termine = array();
	foreach($stunden as $stunde){
		if($tmp['wtag'] != $stunde['wochentag']){ # Tag unterschiedlich -> neuen Termin beginnen
			if($tmp['wtag'] != -1){
				$termine[] = $tmp;
			}
			$tmp['wtag'] = $stunde['wochentag'];
			$tmp['anfang'] = $stunde['anfang'];
			$tmp['ende'] = $stunde['ende'];
		}
		else{ # Tag ist identisch mit dem gespeicherten
			if($tmp['ende'] == $stunde['anfang']){ # Anfang stimmt mit dem Ende der Gruppe vorher überein -> fortführen
				$tmp['ende'] = $stunde['ende'];
				$tmp['gruppen']++;
			}
			else{ # Lücke zwischen zwei Stunden -> neuer Termin am gleichen Tag
				if($tmp['wtag'] != -1){
					$termine[] = $tmp;
				}
				$tmp['wtag'] = $stunde['wochentag'];
				$tmp['anfang'] = $stunde['anfang'];
				$tmp['ende'] = $stunde['ende'];
			}
		}
	}
	if($tmp['wtag'] != -1){
		$termine[] = $tmp;
	}
	
	$stunden = array();
	foreach($termine as $term){
		if(!isset($stunden[$term['wtag']])){
			$stunden[$term['wtag']] = array();
		}
		$stunden[$term['wtag']][] = array('anfang' => $term['anfang'], 'ende' => $term['ende'], 'gruppen' => $term['gruppen']);
	}
	$param = array();
	$param['von'] = ($halbjahr==1?1:7).' '.$jahr;
	$param['bis'] = ($halbjahr==1?6:12).' '.$jahr;
	$trainingstage = array();
	$form = '%s|G|'.str_replace('|','',$conf['taetigkeit']).'|%s|'.str_replace('|','',$conf['bemerkung']);
	foreach($stunden as $wtag => $training){
		$trainingsmonate = $this->kal->holeTrainingstage($wtag,$param['von'],$param['bis']);
		foreach($trainingsmonate as $t){
			foreach($t['t'] as $t2){
				foreach($training as $tr){
					$teile = explode(':',$tr['anfang']);
					$teilnehmer = rand($tr['gruppen']*10,$tr['gruppen']*15);
					$trainingstage[mktime($teile[0], $teile[1], 0, $t['m'], $t2, $t['j'])] = sprintf($form, $tr['ende'], $teilnehmer);
				}
			}
		}
	}
	$this->daten[$key] = $trainingstage;
	$this->datengeaendert = true;
	return true;
}


function generierePdfDatei($id){
	require_once(PFAD_INCLUDE.'class/pdf.inc.php');
	$pdf = new tkpdf;
	$_schriftgroesse = 12;
	$leer = ($id=='leer');
	# Einstellungen holen
	$conf = array();
	if($leer){
		$conf['leertyp'] = 'trainer';
		$conf['jahr'] = '';
		$conf['_einst'] = array(
			'name'    => '',
			'kontonr' => '',
			'blz'     => ''
		);
	}
	else{
		list($conf['jahr'],$conf['halbjahr']) = explode('_',$id,2);
		global $_einst;
		$conf['_einst'] = $_einst['stundennachweis'];
	}
	$conf['zeitraumvon'] = $leer?'':'01.0'.($conf['halbjahr']==1?'1.':'7.').$conf['jahr'];
	$conf['zeitraumbis'] = $leer?'':($conf['halbjahr']==1?'30.06.':'31.12.').$conf['jahr'];
	$conf['leer'] = $leer;
	$conf['schriftgroesse'] = $_schriftgroesse;
	$daten = array();
	if($leer){
		$this->_pdfseite_trainer($pdf, $conf, $daten);
		$pdf->tk_titel = 'leerer Stundennachweiszettel';
	}
	else{
		# Daten holen
		$ini = parse_ini_file($this->datenpfad.$this->dateiname,true);
		$ini = $ini[$id];

		# Daten aufbereiten, Anzahl der Stunden berechnen
		foreach($ini as $key => $werte){
			$tmp = explode('|',$werte);
			$zeile = array(
				'datum' => date('d.m.Y',$key),
				'anfangszeit' => date('H:i',$key),
				'endzeit' => $tmp[0],
				'taetigkeit' => $tmp[2],
				'anzahl' => $tmp[3],
				'bemerkung' => $tmp[4]
			);
			list($a_s, $a_m) = explode(':', $zeile['anfangszeit']);
			list($e_s, $e_m) = explode(':', $zeile['endzeit']);
			$a_insg = $a_s+($a_m/60);
			$e_insg = $e_s+($e_m/60);
			$zeile['stunden'] = ($e_insg-$a_insg)*60;
			$ini[$key] = $zeile;
		}
		$daten = $ini;

		# Daten auf die Seiten verteilen und PDF-Daten erzeugen
		$seitevoll = false;
		$seitequartal = $conf['_einst']['eineseitepromonat']==1?true:false;
		$seite = array();
		$i = 0;
		$quartal = $monat = 0;
		foreach($daten as $key => $row){
			if($quartal != 0 and $seitequartal and $quartal != ceil(date('n',$key)/3)){
				$this->_pdfseite_trainer($pdf, $conf, $seite);
				$seitevoll = true;
			}
			if($seitevoll){
				$i = 0;
				$pdf->ezNewPage();
				$seitevoll = false;
				$seite = array();
			}
			$seite[] = array(
				'datum'        => $row['datum'],
				'zeit'         => $row['anfangszeit'].'-'.$row['endzeit'],
				'stunden'      => $row['stunden'],
				'sportart'     => $row['taetigkeit'],
				'anzahl'       => $row['anzahl'],
				'sportstaette' => $row['bemerkung']
			);
			$i++;
			$quartal = ceil(date('n',$key)/3);
			$monat = date('n',$key);
			if($i >= 22){
				$this->_pdfseite_trainer($pdf, $conf, $seite);
				$seitevoll = true;
			}
		}
		if($i > 0){
			$this->_pdfseite_trainer($pdf, $conf, $seite);
			$seitevoll = true;
		}
		$pdf->tk_titel = 'Stundennachweis für das '.$conf['halbjahr'].'. Halbjahr '.$conf['jahr'].' von '.$_SESSION['user']['realname'];
	}
	$pdf->tk_autor = $_SESSION['user']['realname'];
	# raus damit
	$dateiname = 'stundennachweis_'.($leer?'leer':$_SESSION['user']['name']).'.pdf';
	$pdf->tkstream($dateiname, false);
}


function _pdfseite_trainer(&$pdf, $conf, $daten){
	# Name
	$pdf->line(54,800,475,800);
	$pdf->line(54,772,475,772);
	$pdf->line(54,800,54,772);
	$pdf->line(475,800,475,772);
	$pdf->addText(65.3,780.5,$conf['schriftgroesse']+3,'Name des Übungsleiters/Helfers:');
	$pdf->line(288,777.7,470,777.7);
	if(!$conf['leer']){
		$pdf->addText(290,780,$conf['schriftgroesse']+3, $conf['_einst']['name']);
	}
	# Logo
	if(file_exists(PFAD_INCLUDE.'export/bilder/trainerabrechnung_logo.png')){
		$tmp = getImageSize(PFAD_INCLUDE.'export/bilder/trainerabrechnung_logo.png');
		$breite = round($tmp[0]/1.5);
		$hoehe  = round($tmp[1]/1.5);
		$pdf->addPngFromFile(PFAD_INCLUDE.'export/bilder/trainerabrechnung_logo.png', 485, 705, $breite, $hoehe);
	}
	# Hinweistext
	$hinweistexte = [
		'Die unten aufgeführten Übungsstunden wurden von mir selbst abgehalten.',
		'Diese Übersicht ist bis 15.1. für die im 4. Quartal des Vorjahres erteilten ÜL-Std.,',
		'bis 15.4. für die im 1. Quartal, bis 15.7. für die im 2. Quartal und bis 15.10. für die im',
		'3. Quartal des laufenden Kalenderjahres erteilten Übungsstunden vom Übungs- und',
		'Abteilungsleiter unterschrieben abzugeben. Auszahlung ca. am 10. des Folgemonats.'
	];
	$hconf = [
		'start' => 760,
		'abstand' => 13.2,
		'schrift' => $conf['schriftgroesse']-1.6
	];
	foreach($hinweistexte as $key => $hinweis){
		$pdf->addText(56, $hconf['start']-($hconf['abstand']*$key), $hconf['schrift'], $hinweis);
	}

	# Kasten über Tabelle
	$pos = [
		'xl' => 54,  'xr' => 558,
		'yo' => 700, 'yu' => 658,
	];
	$pdf->line($pos['xl'],$pos['yo'],$pos['xr'],$pos['yo']); # oben
	$pdf->line($pos['xl'],$pos['yu'],$pos['xr'],$pos['yu']); # unten
	$pdf->line($pos['xl'],$pos['yo'],$pos['xl'],$pos['yu']); # links
	$pdf->line($pos['xr'],$pos['yo'],$pos['xr'],$pos['yu']); # rechts
	$pdf->addText(65.3,683.5,$conf['schriftgroesse']+3,'Übersicht über die abgehaltenen Übungsstunden des Jahres:');
	$pdf->line(475,682,550,682);
	if(!$conf['leer']){
		$pdf->addText(480,683.5,$conf['schriftgroesse']+3,'<b>'.$conf['jahr'].'</b>');
	}
	$pdf->addText(80,665,$conf['schriftgroesse']+2,'von:');
	$pdf->line(110,663,210,663);
	$pdf->addText(240,665,$conf['schriftgroesse']+2,'bis:');
	$pdf->line(265,663,365,663);
	if(!$conf['leer']){
		$pdf->addText(120,665,$conf['schriftgroesse']+2,$conf['zeitraumvon']);
		$pdf->addText(275,665,$conf['schriftgroesse']+2,$conf['zeitraumbis']);
	}

	# Tabelle mit den Daten
	$y = 650;
	$oberkante_tabelle = $y;
	$pdf->line(54,$oberkante_tabelle,558,$oberkante_tabelle); # oberste Linie
	# senkrechte Linien
	$pdf->line(54, $oberkante_tabelle, 54, $oberkante_tabelle-523.7);
	$pdf->line(129, $oberkante_tabelle, 129, $oberkante_tabelle-523.7);
	$pdf->line(206.8, $oberkante_tabelle, 206.8, $oberkante_tabelle-523.7);
	$pdf->line(298.8, $oberkante_tabelle, 298.8, $oberkante_tabelle-523.7);
	$pdf->line(412, $oberkante_tabelle, 412, $oberkante_tabelle-523.7);
	$pdf->line(468.6, $oberkante_tabelle, 468.6, $oberkante_tabelle-523.7);
	$pdf->line(557.8, $oberkante_tabelle, 557.8, $oberkante_tabelle-523.7);
	# Texte
	$pdf->ezSetY($oberkante_tabelle);
	$pdf->ezText('Tag',$conf['schriftgroesse']-2,array('aleft'=>54,'aright'=>129,'justification'=>'center'));
	$pdf->ezSetY($oberkante_tabelle);
	$pdf->ezText("Übungszeit  \nvon - bis",$conf['schriftgroesse']-2,array('aleft'=>129,'aright'=>206.8,'justification'=>'center'));
	$pdf->ezSetY($oberkante_tabelle);
	$pdf->ezText("Zeit in Minuten\n(Nr. B 3.1.1 der RL\n1 ÜL-Std. = 45 Min.)",$conf['schriftgroesse']-2.3,array('aleft'=>206.8,'aright'=>298.8,'justification'=>'center','leading'=>10));
	$pdf->ezSetY($oberkante_tabelle);
	$pdf->ezText('Sportart',$conf['schriftgroesse']-2,array('aleft'=>298.8,'aright'=>412,'justification'=>'center'));
	$pdf->ezSetY($oberkante_tabelle);
	$pdf->ezText("Anzahl\nTeilnehmer",$conf['schriftgroesse']-2,array('aleft'=>412,'aright'=>468,6,'justification'=>'center'));
	$pdf->ezSetY($oberkante_tabelle);
	$pdf->ezText('Sportstätte ',$conf['schriftgroesse']-2,array('aleft'=>468,6,'aright'=>557.8,'justification'=>'center'));

	$hoehe_ueberschriften = 35;
	$y -= $hoehe_ueberschriften;
	for($i=0;$i<=22;$i++){
		$pdf->line(54,$y,558,$y);
		$y -= 22.2;
	}
	$y = $oberkante_tabelle-$hoehe_ueberschriften-$conf['schriftgroesse']*1.5;
	$summe = 0;
	foreach($daten as $row){
		$pdf->addText(54+4, $y, $conf['schriftgroesse'], $row['datum']);
		$pdf->addText(129+4, $y, $conf['schriftgroesse'], $row['zeit']);
		$pdf->addText(206.8+40, $y, $conf['schriftgroesse'], $row['stunden']);
		$summe += $row['stunden'];
		$pdf->addText(298.8+4, $y, $conf['schriftgroesse'], $row['sportart']);
		$pdf->addText(412+20, $y, $conf['schriftgroesse'], $row['anzahl']);

		$pdf->addText(468.6+4, $y, $conf['schriftgroesse'], $row['sportstaette']);
		$y -= 22.2;
	}
	# Summe der Stunden
	$pdf->line(129,$oberkante_tabelle-523.7,129,$oberkante_tabelle-523.7-22.2);
	$pdf->line(206.8,$oberkante_tabelle-523.7,206.8,$oberkante_tabelle-523.7-22.2);
	$pdf->line(298.8,$oberkante_tabelle-523.7,298.8,$oberkante_tabelle-523.7-22.2);
	$pdf->line(129,$oberkante_tabelle-523.7-22.2,298.8,$oberkante_tabelle-523.7-22.2);
	$pdf->addText(133, 108, $conf['schriftgroesse']+1, '<b>Summe:</b>');
	if(!$conf['leer']){
		$pdf->addText(206.8+35, 108, $conf['schriftgroesse']+1, '<b>'.$summe.'</b>');
	}
	# Fusstext, Unterschriftzeilen
	$pdf->addText(54,88,$conf['schriftgroesse'],'Die Richtigkeit der obigen Eintragungen wird hiermit bestätigt:');
	$pdf->line(54,48,167,48);
	$pdf->line(181,48,323,48);
	$pdf->line(337,48,549,48);
	$pdf->addText(98,38,$conf['schriftgroesse']-3,'(Datum)');
	$pdf->addText(182,38,$conf['schriftgroesse']-3,'(Bestätigung des Abteilungsleiters)');
	$pdf->addText(378,38,$conf['schriftgroesse']-3,'(Unterschrift des Übungsleiters)');
	# Version
	$pdf->addText(485,20,$conf['schriftgroesse']-4,'<i>Vorlagenversion: 2019-10</i>');
	return;
}

function leseDaten(){
	if(!file_exists($this->datei)){
		if(!$this->_legeDateiAn($this->dateiname)){
			return false;
		}
	}
	if(!is_readable($this->datei)){
		return false;
	}
	$this->daten = parse_ini_file($this->datei,true);
	return true;
}

function schreibeDaten(){
	if(!$this->datengeaendert){
		return false;
	}
	foreach($this->daten as $key => $halbjahr){
		ksort($halbjahr);
		$this->daten[$key] = $halbjahr;
	}
	ksort($this->daten);

	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	schreibe_ini_datei($this->datei,$this->daten,true);
}

function _legeDateiAn($dateiname){
	if(TKSWIM_SCHREIBSCHUTZ){
		trigger_error('[tkswim][class/stundennachweis/_legedateian] Die Datei konnten wegen aktivierem Schreibschutz nicht angelegt werden.', E_USER_ERROR);
	}
	if(empty($this->user) or empty($this->datenpfad)){
		return false;
	}
	if(!is_writable($this->datenpfad)){
		return false;
	}
	$fh = fopen($this->datei,'w');
	fclose($fh);
	chmod($this->datei, 0666);
	return true;
}

} # Ende der Klasse, EOF
