<?php
$updates['0.10.0'] = [
	'dateienupdate' => array(
		'htaccess',
		'config'
	),
	'querys' => [
		"ALTER TABLE ".DB_PREFIX."logins CHANGE passwort passwort_alt varchar(32)",
		"ALTER TABLE ".DB_PREFIX."logins ADD passwort varchar(255) NULL AFTER salz",
		"ALTER TABLE ".DB_PREFIX."wettkaempfe CHANGE datum datum DATE NOT NULL",
		"ALTER TABLE ".DB_PREFIX."wettkaempfe CHANGE meldegeld meldegeld varchar(150) NULL, CHANGE meldeadresse meldeadresse mediumtext NULL, CHANGE sonstiges sonstiges mediumtext NULL",
		"UPDATE ".DB_PREFIX."wettkaempfe SET meldegeld = NULL WHERE meldegeld = ''",
		"UPDATE ".DB_PREFIX."wettkaempfe SET meldeadresse = NULL WHERE meldeadresse = ''",
		"UPDATE ".DB_PREFIX."wettkaempfe SET sonstiges = NULL WHERE sonstiges = ''",
		"UPDATE ".DB_PREFIX."wettkaempfe SET meldeadresse = REPLACE(meldeadresse,'\r','')",
		"ALTER TABLE ".DB_PREFIX."dateien CHANGE angelegt angelegt DATETIME NOT NULL, CHANGE letzteaenderung letzteaenderung DATETIME NOT NULL",
		"ALTER TABLE ".DB_PREFIX."dateien CHANGE userid userid smallint(5) unsigned NULL DEFAULT NULL",
		"ALTER TABLE ".DB_PREFIX."verzeichnisse CHANGE userid userid smallint(5) unsigned NULL DEFAULT NULL",
		"UPDATE ".DB_PREFIX."verzeichnisse SET rechte = CONCAT(LEFT(rechte,6),'r',RIGHT(rechte,2)) WHERE id = 1",
		"UPDATE ".DB_PREFIX."mitglieder SET eingetreten = '1000-01-01' WHERE eingetreten < '1900-01-01'",
		"ALTER TABLE ".DB_PREFIX."mitglieder CHANGE gebdatum gebdatum DATE NOT NULL, CHANGE eingetreten eingetreten DATE NULL DEFAULT NULL",
		"UPDATE ".DB_PREFIX."mitglieder SET eingetreten = NULL WHERE eingetreten = '1000-01-01'",
		"ALTER TABLE ".DB_PREFIX."mitglieder DROP homeverzeichnisid",
		"ALTER TABLE ".DB_PREFIX."wettkaempfe DROP verzeichnisid",
		"ALTER TABLE ".DB_PREFIX."abschnitte CHANGE datum datum DATE NOT NULL",
		"ALTER TABLE ".DB_PREFIX."termine CHANGE datum datum DATETIME NOT NULL",
		"ALTER TABLE ".DB_PREFIX."zeiten CHANGE datum datum DATE NOT NULL"
	],
	'kontrollquery' => "SELECT 1 as ok FROM information_schema.COLUMNS WHERE TABLE_SCHEMA = '".DB_NAME."' AND TABLE_NAME = '".DB_PREFIX."logins' AND COLUMN_NAME = 'passwort_alt'",
	'funktion' => 'beides',
	'hinweise' => [
		'Homeverzeichnise wurden entfernt, bestehende Verzeichnisse werden gelöscht. Verzeichnisse mit Inhalt
			bleiben bei nicht ausgetretenen Mitgliedern erhalten',
		'Die Unterstützung von Bildern wurde entfernt, bestehende Bilder werden gelöscht (eine Kopie wird vorher im Sicherungs-Verzeichnis abgelegt)',
		'Daten ausgetretener Mitglieder werden automatisch gelöscht (standardmäßig Adressen, Telefonnummern und E-Mailadressen)'
	]
];

function update_0_10_0_anfang(){
	global $_db;

	## gc-Einstellung für das Löschen der Daten ehemaliger Mitglieder schreiben
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	$datei = PFAD_INCLUDE.'conf/cronjob.ini';
	$inh = parse_ini_file($datei, true);
	$inh['gc']['datenehemaligermitglieder'] = 'adresse;telefon;email';
	schreibe_ini_datei($datei, $inh, true);

	## Bilder löschen
	if(!is_writable(PFAD_INCLUDE.'sicherung')){
		die('Das Verzeichnis »'.PFAD_INCLUDE.'sicherung« ist nicht beschreibbar. Bitte Rechte anpassen und Update neu starten.');
	}
	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	# alle Bilder suchen und in zip-Datei schreiben
	$dateien = glob(PFAD_BILDER.'alben/*/*/*/*/*/*');
	foreach($dateien as $datei){
		$name = substr($datei, strlen(PFAD_BILDER));
		$zip->addFile_pfad($datei, $name, filemtime($datei));
	}
	$bildertabellen = [
		DB_PREFIX.'bilder_alben',
		DB_PREFIX.'bilder_bilder',
		DB_PREFIX.'bilder_kommentare',
		DB_PREFIX.'bilder_markierungen'
	];
	# Datenbanktabellen exportieren
	$dbdaten = $_db->exportiereDatenbank('', $bildertabellen);
	$zip->addFile_daten($dbdaten, date('Y-m-d_H-i').'_'.substr(DB_PREFIX,0,-1).'.sql', time());
	# zip-Datei schreiben
	$zip->speichereDatei(PFAD_INCLUDE.'sicherung/'.date('Y-m-d_H-i').'_bilder-vor-loeschung.zip');
	# Bilder löschen
	$pfade = [];
	foreach($dateien as $datei){
		$pfade[] = dirname($datei);
		unlink($datei);
	}
	# Verzeichnise löschen
	$pfade = array_unique($pfade);
	for($i=0;$i<6;$i++){
		foreach($pfade as $key => $pfad){
			rmdir($pfad);
			$pfade[$key] = dirname($pfad);
		}
		$pfade = array_unique($pfade);
	}
	# Bildertabellen löschen
	foreach($bildertabellen as $tabelle){
		$query = "DROP TABLE ".$tabelle;
		$_db->fuehreQueryAus($query);
	}
	# Bilderrechte löschen
	$_db->fuehreQueryAus("DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid IN ('s_bilder_anzeigen','s_bilder_bearbeiten',
		's_bilder_allebearbeiten','s_bilder_kommentarebearbeiten','s_bilder_meldungenbearbeiten')");
	$_db->fuehreQueryAus("DELETE FROM ".DB_PREFIX."rechte WHERE id IN ('s_bilder_anzeigen','s_bilder_bearbeiten','s_bilder_allebearbeiten',
		's_bilder_kommentarebearbeiten','s_bilder_meldungenbearbeiten')");
}

function update_0_10_0_ende(){
	global $_db;
	## Userverzeichnisse bearbeiten (leere Verzeichnise löschen, bei ausgetretenen Mitgliedern Inhalt löschen, sonst so lassen)
	# Userverzeichnisse selbst holen
	$query = "SELECT v.id, IF(m.ausgetreten IS NULL,0,1) as ausgetreten, 0 as inhalt
				FROM ".DB_PREFIX."verzeichnisse as v LEFT JOIN ".DB_PREFIX."mitglieder as m  ON v.userid=m.id
				WHERE v.parentid = 1";
	$_db->holeDaten($query);
	$userverzeichnisse = $_db->baueArray('*', 'id');
	$loeschen = ['v' => [], 'd' => []];
	$leeren = [];
	if(count($userverzeichnisse) > 0){
		# prüfen ob Inhalten in den Userverzeichnissen vorhanden sind
		$ids = implode(',',array_keys($userverzeichnisse));
		$query = "SELECT parentid FROM ".DB_PREFIX."verzeichnisse WHERE parentid IN (".$ids.")
					UNION
				  SELECT verzeichnisid FROM ".DB_PREFIX."dateien WHERE verzeichnisid IN (".$ids.")";
		$_db->holeDaten($query);
		$inhalt = $_db->baueArray('parentid', '#');
		foreach($inhalt as $verzeichnis){
			$userverzeichnisse[$verzeichnis]['inhalt'] = 1;
		}
		# Userverzeichnisse durchgehen und …
		foreach($userverzeichnisse as $uvid => $verzeichnis){
			# … löschen wenn leer
			if($verzeichnis['inhalt'] == 0){
				$loeschen['v'][$uvid] = $uvid;
			}
			# … ignorieren wenn Inhalt existiert und Mitglied nicht ausgetreten ist
			if($verzeichnis['inhalt'] == 1 and $verzeichnis['ausgetreten'] == 0){
				continue;
			}
			# … leeren wenn Inhalt existiert und Mitglied ausgetreten ist
			if($verzeichnis['inhalt'] == 1 and $verzeichnis['ausgetreten'] == 1){
				$leeren[$uvid] = $uvid;
			}
		}
	}
	# zu leerende Userverzeichnise durchsuchen
	if(count($leeren) > 0){
		# rekursiv alle Verzeichnise der zu leerenden Verzeichnise holen
		$verzeichnisse = update_0_10_0_ende_holeUnterverzeichnisse($_db, $leeren, []);
		$loeschen['v'] += $verzeichnisse;
		# Dateien in den zu leerenden Verzeichnise holen
		$query = "SELECT id, systemname FROM ".DB_PREFIX."dateien WHERE verzeichnisid IN (".implode(',',$verzeichnisse).")";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() > 0){
			$loeschen['d'] = $_db->baueArray('systemname', 'id');
		}
	}
	# Verzeichnisse löschen
	if(count($loeschen['v']) > 0){
		$query = "DELETE FROM ".DB_PREFIX."verzeichnisse WHERE id IN (".implode(',',$loeschen['v']).")";
		$_db->fuehreQueryAus($query);
	}
	# Dateien löschen
	if(count($loeschen['d']) > 0){
		$query = "DELETE FROM ".DB_PREFIX."dateien WHERE id IN (".implode(',',array_keys($loeschen['d'])).")";
		$_db->fuehreQueryAus($query);
		foreach($loeschen['d'] as $dateiname){
			if(!file_exists(PFAD_DATEIEN.$dateiname)){
				continue;
			}
			unlink(PFAD_DATEIEN.$dateiname);
		}
	}
}

# Hilfsfunktion um rekursiv die Unterverzeichnise von Userverzeichnissen ausgetretener Mitglieder zu holen
function update_0_10_0_ende_holeUnterverzeichnisse($_db, $parents, $verzeichnisse){
	$verzeichnisse = $verzeichnisse+$parents;
	$query = "SELECT id FROM ".DB_PREFIX."verzeichnisse WHERE parentid IN (".implode(',',$parents).")";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() > 0){
		$parents = $_db->baueArray('id', 'id');
		$verzeichnisse = update_0_10_0_ende_holeUnterverzeichnisse($_db, $parents, $verzeichnisse);
	}
	return $verzeichnisse;
}

# EOF
