<?php
# Modul: wkabwickeln_dmsj
/*
Wettkampfabwicklung, Aktion: dmsj_ergebnisse2manschaften
verwendete Templates:
 - 42.dmsj-mannschaftenzuordnen.inc.html
*/

# Mannschaften
$mannschaften = array();
foreach($_wkeinst['dmsj'] as $nr => $mitgl){
	$jugend = $nr[0];
	$mannsch = substr($nr,1);
	$mannschaften[$nr] = $mannsch.'. Mannschaft Jugend '.strtoupper($jugend);
}

# Starts
$starts = array();
foreach($_wkeinst as $key => $inhalt){
	if(substr($key,0,4) != 'erg_'){
		continue;
	}
	list($wknr,$art,,$strecke,$disziplin,$mw) = explode(';',$inhalt['_wk']);

	foreach($inhalt as $key2 => $mannschaft){
		if($key2 === '_wk'){
			continue;
		}
		list(,$mannschaftsnr,) = explode(';',$mannschaft);
		$starts[$wknr.'_'.$key2] = $strecke.'m '.$_lagen[$disziplin].' '.$_geschlechter[$mw].' (WK '.$wknr.($art=='N'?', Nachschwimmen':'').')';
		$starts[$wknr.'_'.$key2] .= ' - '.$mannschaftsnr.'. Mannschaft';
	}
}

if(isset($_POST['speichern'])){
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	$f = '';
	foreach($_POST['gespeichert'] as $wkkey => $m){
		$f .= pruefen($wkkey,'wertemenge','Der Wettkampf ist ungültig',array_keys($starts));
		if($m == '-'){
			$f .= 'Es müssen allen Wettkämpfen Mannschaften zugewiesen werden.<br />';
		}
		else{
			$f .= pruefen($m,'wertemenge','Die Mannschaft ist ungültig',array_keys($mannschaften));
		}
	}
	if(empty($f)){
		$ms = array();
		foreach($_POST['gespeichert'] as $wkkey => $m){
			if(!isset($ms[$m])){
				$ms[$m] = array();
			}
			$ms[$m][] = $wkkey;
		}
		$_wkeinst['wkzuordung'] = array();
		foreach($ms as $mannschaft => $start){
			$_wkeinst['wkzuordung'][$mannschaft] = implode(';',$start);
		}
		schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG,'Die Zuordungen wurden gespeichert.');
	}
	else{
		$_tmpl->assign('fehler',$f);
		$gespeichert = $_POST['gespeichert'];
	}
}

# schon gespeicherte ermitteln
if(!isset($gespeichert)){
	$gespeichert = array();
	if(isset($_wkeinst['wkzuordung'])){
		foreach($_wkeinst['wkzuordung'] as $mannschaft => $wks){
			$einzelwks = explode(';',$wks);
			foreach($einzelwks as $w){
				$gespeichert[$w] = $mannschaft;
			}
		}
	}
	else{ # Zuordung ermitteln
		$wettkaempfe = ermittleDmsjWettkamfNummern($_SESSION['wk_abwickeln']['id']);
		foreach($wettkaempfe as $key => $wert){
			$wk2mannschaft[$wert['nr']] = $key[0];
		}
		foreach($starts as $key => $start){
			list($wknr,) = explode('_',$key);
			$jugend = $wk2mannschaft[(int)substr($wknr,-2)];
			foreach($mannschaften as $m => $mannsch){
				if($m[0] == $jugend){
					$gespeichert[$key] = $m;
				}
			}
		}
	}
}

function ermittleDmsjWettkamfNummern($wknr){
	global $_db;
	if(!preg_match('~^[0-9]+$~D',$wknr)){
		return false;
	}
	$query = "SELECT wert FROM ".DB_PREFIX."eigenschaften
				WHERE art = 'w' AND artid = '".$wknr."' AND eigenschaft = 'wettkampfart' AND wert = 'dmsj'";
	$_db->holeDaten($query);
	if($_db->ergebnis['anzahl'] == 0){
		return false;
	}
	$query = "SELECT a.nr, w.wknr, w.disziplin, w.jahrgang
				FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
				WHERE a.wettkampfid = ".$wknr." AND a.id = w.abschnittid
				ORDER BY a.nr, w.wknr";
	$_db->holeDaten($query);
	if($_db->ergebnis['anzahl'] == 0){
		return false;
	}
	$wettkaempfe = array();
	foreach($_db->ergebnis['daten'] as $row){
		list($sort1,$sort2) = explode(';',str_replace(' ','',$row['jahrgang']));
		$sort1 = explode(',',$sort1);
		$sort2 = explode(',',$sort2);
		$sort1_art = strlen($sort1[0])==1?'mw':'jugend';
		$sort2_art = strlen($sort2[0])==1?'mw':'jugend';
		$anz1 = count($sort1);
		$anz2 = count($sort2);

		$wknr = $row['wknr'];

		for($i1=0;$i1<$anz1;$i1++){
			for($i2=0;$i2<$anz2;$i2++){
				$tmp = array(
					'nr'        => $wknr,
					'abschnitt' => $row['nr'],
					'disziplin' => $row['disziplin'],
					'mw'        => ($sort1_art=='mw'?$sort1[$i1]:$sort2[$i2]),
					'jugend'    => ($sort1_art=='jugend'?$sort1[$i1][1]:$sort2[$i2][1])
				);
				$key = $tmp['jugend'].$tmp['mw'].$tmp['disziplin'];
				$wettkaempfe[$key] = $tmp;
				$wknr++;
			}
		}
	}
	return $wettkaempfe;
}


$_tmpl->assign('gespeichert',$gespeichert);
$_tmpl->assign('mannschaften',$mannschaften);
$_tmpl->assign('starts',$starts);
$_inh .= $_tmpl->fetch('wettkaempfe/42.dmsj-mannschaftenzuordnen.inc.html');
# EOF
?>