<?php
# Modul: wkabwickeln_dmsj
/*
Wettkampfabwicklung, Aktion: dmsj_pdf_startkarten
verwendete Templates:
 - [keines]
*/

/*
obere Grenze:  Rand aus den Einstellungen \ die Karten teilen sich dann den
untere Grenze: Rand aus den Einstellungen / verbleibenden Platz
linke Grenze:  20mm (57pt) - egal was in den Einstellungen steht
rechte Grenze: min 10mm (28pt) je nach Einstellungen bis zu 20mm (bei einer Einstellung ueber 20mm werden trotzdem 20mm verwendet!)
*/
require_once(PFAD_INCLUDE.'class/pdf.inc.php');
$pdf = new tkpdf(10);
$raender = $pdf->holeRandabstaende('pt');
$raender['links_original'] = $raender['links'];
$raender['rechts_original'] = $raender['rechts'];
$raender['rechts'] = ($raender['rechts']<=28.35)?28.35:(($raender['rechts']>=56.69)?56.69:$raender['rechts']);

$raender['oben'] = $raender['unten'] = 0;
$raender['links'] = 56.69;
$raender['rechts'] = ($raender['rechts']<=28.35)?28.35:(($raender['rechts']>=56.69)?56.69:$raender['rechts']);
$wettkaempfe = ermittleDmsjWettkampfNummern($_SESSION['wk_abwickeln']['id']);
$schriftgroesse = 10;
$spalten = array(
	'nr'       => '<b>#</b>',
	'nachname' => '<b>Nachname</b>',
	'vorname'  => '<b>Vorname</b>',
	'f'        => '<b>Freistil</b>',
	'b'        => '<b>Brust</b>',
	'r'        => '<b>Rücken </b>',
	's'        => '<b>Delfin</b>',
	'jg'       => '<b>JG</b>',
	'dsvid'    => '<b>DSV-ID</b>'
);
$breite = 595.28-($raender['rechts']+10+$raender['links']);
$optionen = array(
	'shaded' => 0,
	'fontSize' => $schriftgroesse,
	'xPos' => $raender['links']+10,
	'xOrientation' => 'right',
	'maxWidth' => $breite,
	'cols' => array(
		'f' => array(
			'width' => 65
		),
		'b' => array(
			'width' => 65
		),
		'r' => array(
			'width' => 65
		),
		's' => array(
			'width' => 65
		)
	)
);
$zeitensucharray = array(
	'f' => array('disziplin' => 1, 'laenge' => 100),
	'b' => array('disziplin' => 2, 'laenge' => 100),
	'r' => array('disziplin' => 3, 'laenge' => 100),
	's' => array('disziplin' => 4, 'laenge' => 100),
);
$rueckseite_spalten = array(
	'nr'     => '#',
	'name'   => 'Name',
	'jg'     => 'JG',
	'dsvid'  => 'DSV-ID',
	'zwzeit' => 'Zwischenzeit'
);
$rueckseite_optionen = array(
	'shaded' => 0,
	'fontSize' => $schriftgroesse+4,
	'xPos' => $raender['rechts']+15,
	'xOrientation' => 'right',
	'showLines' => 2,
	'showHeadings' => 1,
	'rowGap' => 10,
	'cols' => array(
		'nr' => array(
			'width' => 20
		),
		'name' => array(
			'width' => $breite-280
		),
		'jg' => array(
			'width' => 50
		),
		'dsvid' => array(
			'width' => 90
		),
		'zwzeit' => array(
			'width' => 120
		)
	)
);
$rueckseite_daten = array(
	array('nr'=>1,'name'=>'','jg'=>'','dsvid'=>'','zwzeit'=>''),
	array('nr'=>2,'name'=>'','jg'=>'','dsvid'=>'','zwzeit'=>''),
	array('nr'=>3,'name'=>'','jg'=>'','dsvid'=>'','zwzeit'=>''),
	array('nr'=>4,'name'=>'','jg'=>'','dsvid'=>'','zwzeit'=>'')
);
$kartenhoehe = round((841.89-$raender['oben']-$raender['unten'])/3,2); # 268.35
$kartenbreite = 595.28-$raender['rechts']-$raender['links'];
$y = 841.89-$raender['oben'];

if(isset($_wkeinst['dmsj']) and count($_wkeinst['dmsj']) > 0){
	# aktuelle Zeiten holen
	$mannschaften = array();
	$dmannschaft = $emannschaft = array();
	$ids = array();
	foreach($_wkeinst['dmsj'] as $key => $mannschaft)
	{
		if(empty($mannschaft)){
			unset($_wkeinst['dmsj'][$key]);
			continue;
		}
		$mannschaften[$key] = explode('|',$mannschaft);

		$anz = count($mannschaften[$key]);
		for($i=0;$i<$anz;$i++){
			$ids[] = $mannschaften[$key][$i];
		}
		if($key[0] == 'd'){
			for($i=0;$i<$anz;$i++){
				$dmannschaft[$i] = $mannschaften[$key][$i];
			}
		}
		if($key[0] == 'e'){
			for($i=0;$i<$anz;$i++){
				$emannschaft[$i] = $mannschaften[$key][$i];
			}
		}
	}
	if(count($ids) > 0){
		$query = "SELECT CONCAT(mid, '_', laenge, '_', disziplin) as strecke, zeit FROM ".DB_PREFIX."aktuellezeiten
					WHERE mid IN (".implode(',',$ids).") AND laenge IN (25,50,100) AND disziplin IN (1,2,3,4)";
		$_db->holeDaten($query);
		$tmpzeiten = $_db->baueArray('zeit','strecke');
		$zeiten = array();
		foreach($ids as $id){
			$fbrl = in_array($id,$emannschaft)?50:100;
			# Länge der Schmetterling-Strecke (Jugend E: 25m (es gibt keine 25m-aktuelle Zeiten, deswegen 50m), Jugend D: 50m, sonst 100m):
			$sl = (in_array($id,$dmannschaft) or in_array($id,$emannschaft))?50:100; 
			$zeiten[$id]['f'] = isset($tmpzeiten[$id.'_'.$fbrl.'_1'])?substr(text_format(round($tmpzeiten[$id.'_'.$fbrl.'_1'],-2),'schwimmzeit'),1,-3):'';
			$zeiten[$id]['b'] = isset($tmpzeiten[$id.'_'.$fbrl.'_2'])?substr(text_format(round($tmpzeiten[$id.'_'.$fbrl.'_2'],-2),'schwimmzeit'),1,-3):'';
			$zeiten[$id]['r'] = isset($tmpzeiten[$id.'_'.$fbrl.'_3'])?substr(text_format(round($tmpzeiten[$id.'_'.$fbrl.'_3'],-2),'schwimmzeit'),1,-3):'';
			$zeiten[$id]['s'] = isset($tmpzeiten[$id.'_'.$sl.'_4'])?substr(text_format(round($tmpzeiten[$id.'_'.$sl.'_4'],-2),'schwimmzeit'),1,-3):'';
		}
	}

	# Startkarten erzeugen
	$nummern = array();
	foreach($_wkeinst['dmsj'] as $key => $mannschaft){
		$jugend = $key[0];
		$nr = substr($key,1);
		$disziplin = 1;
		if(!empty($mannschaft)){
			$query = "SELECT id, nachname, vorname, RIGHT(YEAR(gebdatum),2) as jg, dsvid, mw
						FROM ".DB_PREFIX."mitglieder WHERE id IN (".str_replace('|',',',$mannschaft).") ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			$mitglieder = $_db->baueArray('*','id');
			$mw = $_db->baueArray('mw','#');
			$pos = 1;
			$sl = $jugend=='d'?50:($jugend=='e'?25:100); # Länge der Schmetterling-Strecke (Jugend E: 25m, Jugend D: 50m, sonst 100m)
			foreach($mitglieder as $key => $m){
				$mitglieder[$key]['nr'] = $pos++;
				$mitglieder[$key]['f'] = $zeiten[$key]['f'];
				$mitglieder[$key]['b'] = $zeiten[$key]['b'];
				$mitglieder[$key]['r'] = $zeiten[$key]['r'];
				$mitglieder[$key]['s'] = $zeiten[$key]['s'];
			}
		}
		else{
			$mitglieder = false;
		}
		$geschlecht = '';
		if($mitglieder !== false){
			$m = $w = false;
			foreach($mw as $g){
				if($g == 'm'){
					$m = true;
				}
				if($g == 'w'){
					$w = true;
				}
			}
			$geschlecht = $m?($w?'x':'m'):'w';
		}	
		if(!isset($nummern[$jugend])){
			$nummern[$jugend] = array();
		}
		if(!isset($nummern[$jugend][$geschlecht])){
			$nummern[$jugend][$geschlecht] = 1;
		}
		else{
			$nummern[$jugend][$geschlecht]++;
		}
		$nr = $nummern[$jugend][$geschlecht];		
		for($s=1;$s<=2;$s++){
			$pdf->setLineStyle(1);
			$y = 841.89-$raender['oben'];
			$pdf->line($raender['links'], $y, 595.28-$raender['rechts'], $y); # Begrenzungslinie oben
			$pdf->line($raender['links'], $raender['unten'], $raender['links'], 841.89-$raender['oben']); # linke Begrenzung
			$pdf->line(595.28-$raender['rechts'], $raender['unten'], 595.28-$raender['rechts'], 841.89-$raender['oben']); # rechte Begrenzung
			for($i=0;$i<3;$i++){

				if($disziplin == 6){ # 6.Startkarte -> Mannschaft draufschreiben
					$tmp_y = $y;
					if($mitglieder !== false){
						$pdf->addText($raender['links']+$kartenbreite/2-119/2, $tmp_y-15, $schriftgroesse+2, '<b>gemeldete Mitglieder</b>'); # 119 = Textbr.
						$mannschaft = $nr.'. Mannschaft, <b>Jugend '.strtoupper($jugend).'</b>, '.$_geschlechter[$geschlecht];
						$pdf->addText($raender['links']+5, $tmp_y-30, $schriftgroesse, 'Mannschaft: '.$mannschaft);
						$pdf->ezSetY($tmp_y-35);
						$pdf->ezTable($mitglieder, $spalten, '', $optionen);
					}
					$tmp_y -= $kartenhoehe;
					$pdf->line($raender['links'], $tmp_y, 595.28-$raender['rechts'], $tmp_y); # Trennlinien am Kartenende
					$pdf->addText($raender['links']+$kartenbreite-87, $tmp_y+15, $schriftgroesse-1, '<i>tkswim.de</i>');
					continue;
				}
				$y -= 10;
				$pdf->addText($raender['links']+$kartenbreite/2-111/2, $y-15, $schriftgroesse+2, '<b>S T A R T K A R T E</b>'); # 111 = Textbreite
				$pdf->setLineStyle(0.1);
				# oberer Teil
				# Beschriftungen
				$pdf->addText($raender['links']+5, $y-30, $schriftgroesse, 'WkNr:');
				$pdf->addText($raender['links']+90, $y-30, $schriftgroesse, 'WkName:');
				$pdf->addText($raender['links']+5, $y-45, $schriftgroesse, 'Name:');
				$pdf->addText($raender['links']+5, $y-60, $schriftgroesse, 'Verein:');
				$pdf->addText($raender['links']+$kartenbreite/2+5, $y-45, $schriftgroesse, 'Jg:');
				$pdf->addText($raender['links']+$kartenbreite/2+5, $y-60, $schriftgroesse, 'Meldezeit:');
				# Texte
				$wknr = empty($geschlecht)?'':$wettkaempfe[$jugend.$geschlecht.$disziplin]['nr'];
				$pdf->addText($raender['links']+40, $y-30, $schriftgroesse+1, '<b>'.$wknr.'</b>');
				$wklaenge = $jugend=='e'?(($disziplin==4 or $disziplin==5)?'25':'50'):(($disziplin==4 and $jugend=='d')?'50':'100');
				$wkname = '4x'.$wklaenge.' '.$_lagen[$disziplin].' '.(empty($geschlecht)?'':$_geschlechter[$geschlecht]);
				$pdf->addText($raender['links']+140, $y-30, $schriftgroesse+1, $wkname);
				$pdf->addText($raender['links']+40, $y-45, $schriftgroesse+1, '<b>'.$nr.'. Mannschaft</b>');
				$pdf->addText($raender['links']+40, $y-60, $schriftgroesse, '<b>'.TKSWIM_VEREIN.'</b> ('.TKSWIM_VEREINSID.')');
				$pdf->addText($raender['links']+$kartenbreite/2+25, $y-45, $schriftgroesse, 'Jugend '.strtoupper($jugend));
				$pdf->addText($raender['links']+$kartenbreite/2+55, $y-60, $schriftgroesse, '-');
				# Trennlinien unter Kartenkopf
				$pdf->line($raender['links'], $y-65, 595.28-$raender['rechts'], $y-65);
				# unterer Teil
				$y -= 65;
				# Beschriftungen
				$pdf->addText($raender['links']+5, $y-13, $schriftgroesse, 'Bemerkungen:');
				$pdf->addText($raender['links']+$kartenbreite/2+5, $y-17, $schriftgroesse+1, '<b>Lauf:</b>');
				$pdf->addText($raender['links']+$kartenbreite/2+90, $y-17, $schriftgroesse+1, '<b>Bahn:</b>');
				$pdf->line($raender['links']+$kartenbreite/2, $y-25, 595.28-$raender['rechts'], $y-25);
				# Trennlinien im unteren Kartenbereich
				$pdf->line($raender['links']+$kartenbreite/2, $y, $raender['links']+$kartenbreite/2, $y-($kartenhoehe-65-10));
				$y -= ($kartenhoehe-65);

				# Endzeit
				$pdf->addText($raender['links']+$kartenbreite/2+5, $y+160, $schriftgroesse+3, 'Endzeit:');
				$pdf->addText(595.28-$raender['rechts']-$kartenbreite/4, $y+70+20, $schriftgroesse+6, '<b>:           ,</b>');
				$y += 10;
				# Unterschriften
				$pdf->addText($raender['links']+5, $y+20+5, $schriftgroesse, 'Unterschrift SCH:');
				$pdf->addText($raender['links']+150, $y+20+5, $schriftgroesse, 'ZN:');
				# Eigenwerbung
				$pdf->addText($raender['links']+$kartenbreite-77, $y+15, $schriftgroesse-2, '<i>tkswim.de</i>');
				$pdf->setLineStyle(1);
				$pdf->line($raender['links'], $y, 595.28-$raender['rechts'], $y); # Trennlinien am Kartenende
				$disziplin++;
			}
			$pdf->ezNewPage();
			# Rueckseite der Startkarten
			$r_disziplin = $s==1?1:4;
			$y = 841.89-$raender['oben']-50;
			$pdf->ezSetY($y);
			for($i=0;$i<3;$i++){
				if($r_disziplin == 6){
					continue;
				}
				if($r_disziplin == 5){
					$pdf->addText($raender['rechts']+23,$y-61,$schriftgroesse-1,'R');
					$pdf->addText($raender['rechts']+23,$y-98,$schriftgroesse-1,'B');
					$pdf->addText($raender['rechts']+23,$y-134,$schriftgroesse-1,'S');
					$pdf->addText($raender['rechts']+23,$y-170,$schriftgroesse-1,'F');
				}
				$pdf->addText(595.28-$raender['links']-48,$y-170,$schriftgroesse,'= Endzeit');
				$pdf->ezTable($rueckseite_daten, $rueckseite_spalten, '', $rueckseite_optionen);
				if($r_disziplin != 3 and $r_disziplin != 6){
					$y -= $kartenhoehe;
					$pdf->ezSetY($y);
				}
				$r_disziplin++;
			}
			$pdf->ezNewPage();
		}
	}
}

# blanko-Meldezettel anhaengen
$pdf->setLineStyle(1);
$y = 841.89-$raender['oben'];
$pdf->line($raender['links'], $y, 595.28-$raender['rechts'], $y); # Begrenzungslinie oben
#$y -= $kartenhoehe;
$pdf->line($raender['links'], $raender['unten'], $raender['links'], 841.89-$raender['oben']); # linke Begrenzung
$pdf->line(595.28-$raender['rechts'], $raender['unten'], 595.28-$raender['rechts'], 841.89-$raender['oben']); # rechte Begrenzung
for($i=0;$i<3;$i++){
	$pdf->addText($raender['links']+$kartenbreite/2-111/2, $y-15, $schriftgroesse+2, '<b>S T A R T K A R T E</b>'); # 111 = Textbreite

	$pdf->setLineStyle(0.1);
	# oberer Teil
	# Beschriftungen
	$pdf->addText($raender['links']+5, $y-30, $schriftgroesse, 'WkNr:');
	$pdf->addText($raender['links']+90, $y-30, $schriftgroesse, 'WkName:');
	$pdf->addText($raender['links']+5, $y-45, $schriftgroesse, 'Name:');
	$pdf->addText($raender['links']+5, $y-60, $schriftgroesse, 'Verein:');
	$pdf->addText($raender['links']+$kartenbreite/2+5, $y-45, $schriftgroesse, 'Jg:');
	$pdf->addText($raender['links']+$kartenbreite/2+5, $y-60, $schriftgroesse, 'Meldezeit:');
	# Texte
	$pdf->addText($raender['links']+40, $y-60, $schriftgroesse, '<b>'.TKSWIM_VEREIN.'</b>');
	$pdf->addText($raender['links']+$kartenbreite/2+55, $y-60, $schriftgroesse, '-');
	# Trennlinien unter Kartenkopf
	$pdf->line($raender['links'], $y-65, 595.28-$raender['rechts'], $y-65);
	# unterer Teil
	$y -= 65;
	# Beschriftungen
	$pdf->addText($raender['links']+5, $y-13, $schriftgroesse, 'Staffelteilnehmer / Beanstandungen');
	$pdf->addText($raender['links']+$kartenbreite/2+5, $y-17, $schriftgroesse+1, '<b>Lauf:</b>');
	$pdf->addText($raender['links']+$kartenbreite/2+90, $y-17, $schriftgroesse+1, '<b>Bahn:</b>');
	$pdf->line($raender['links']+$kartenbreite/2, $y-25, 595.28-$raender['rechts'], $y-25);
	# Zwischenzeiten
	$tmp_y = $y-20-20;
	$tmp_x = $raender['links']+$kartenbreite/2+5;
	for($j=1;$j<=3;$j++){
		$pdf->addText($tmp_x, $tmp_y, $schriftgroesse+1, 'Zwischenzeit '.$j.'                     <b>:         ,</b>');
		$pdf->line($tmp_x-5, $tmp_y-6, 595.28-$raender['rechts'], $tmp_y-6);
		$tmp_y -= 20;
	}
	# Trennlinien im unteren Kartenbereich
	$pdf->line($raender['links']+$kartenbreite/2, $y, $raender['links']+$kartenbreite/2, $y-($kartenhoehe-65));
	$y -= ($kartenhoehe-65);
	# Endzeit
	$pdf->addText($raender['links']+$kartenbreite/2+5, $y+50, $schriftgroesse+4, 'Endzeit                       <b>:         ,</b>');
	# Unterschriften
	$pdf->addText($raender['links']+5, $y+5, $schriftgroesse, 'Unterschrift SCH:');
	$pdf->addText($raender['links']+150, $y+5, $schriftgroesse, 'ZN:');
	# Eigenwerbung
	$pdf->addText($raender['links']+$kartenbreite-77, $y+5, $schriftgroesse-2, '<i>tkswim.de</i>');
	$pdf->setLineStyle(1);
	$pdf->line($raender['links'], $y, 595.28-$raender['rechts'], $y); # Trennlinien am Kartenende
}
$pdf->ezNewPage();
# Rueckseite der Startkarten
$y = 841.89-$raender['oben']-50;
$pdf->ezSetY($y);
$r_disziplin = 1;
for($i=0;$i<3;$i++){
	$pdf->addText(595.28-$raender['links']-48,$y-170,$schriftgroesse,'= Endzeit');
	$pdf->ezTable($rueckseite_daten, $rueckseite_spalten, '', $rueckseite_optionen);
	if($r_disziplin != 3){
		$y -= $kartenhoehe;
		$pdf->ezSetY($y);
	}
	$r_disziplin++;
}
$pdf->tk_autor = $_SESSION['user']['realname'];
$pdf->tk_titel = 'Startkarten für '.(isset($_wkeinst['meldezettel']['rueckmeldungfuer'])?$_wkeinst['meldezettel']['rueckmeldungfuer']:$_wkeinst['wettkampfdaten']['titel']);
$pdf->tkstream('startkarten.pdf');


#### Funktionen ########################################################
function ermittleDmsjWettkampfNummern($wknr){
	global $_db;
	if(!preg_match('~^[0-9]+$~D',$wknr)){
		return false;
	}
	$query = "SELECT wert FROM ".DB_PREFIX."eigenschaften
				WHERE art = 'w' AND artid = '".$wknr."' AND eigenschaft = 'wettkampfart' AND wert = 'dmsj'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() == 0){
		return false;
	}
	$query = "SELECT a.nr, w.wknr, w.disziplin, w.jahrgang
				FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
				WHERE a.wettkampfid = ".$wknr." AND a.id = w.abschnittid
				ORDER BY a.nr, w.wknr";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() == 0){
		return false;
	}
	$wettkaempfe = array();
	foreach($_db->ergebnis['daten'] as $row){
		list($sort1,$sort2) = explode(';',str_replace(' ','',$row['jahrgang']));
		$sort1 = explode(',',$sort1);
		$sort2 = explode(',',$sort2);
		$sort1_art = strlen($sort1[0])==1?'mw':'jugend';
		$sort2_art = strlen($sort2[0])==1?'mw':'jugend';
		$anz1 = count($sort1);
		$anz2 = count($sort2);

		$wknr = $row['wknr'];

		for($i1=0;$i1<$anz1;$i1++){
			for($i2=0;$i2<$anz2;$i2++){
				$tmp = array(
					'nr'        => $wknr,
					'abschnitt' => $row['nr'],
					'disziplin' => $row['disziplin'],
					'mw'        => ($sort1_art=='mw'?$sort1[$i1]:$sort2[$i2]),
					'jugend'    => ($sort1_art=='jugend'?$sort1[$i1][1]:$sort2[$i2][1])
				);
				$key = $tmp['jugend'].$tmp['mw'].$tmp['disziplin'];
				$wettkaempfe[$key] = $tmp;
				$wknr++;
			}
		}
	}
	return $wettkaempfe;
}

# EOF
?>