<?php
/*
Wettkampfabwicklung, Aktion: ruecklaufzettel
verwendete Templates:
 - 42.ruecklaufzettel-uebersicht.inc.html
 - 42.ruecklaufzettel-teilnehmer.inc.html
*/
$_fahrtkaestchen = true;
if(isset($_wkeinst['meldezettel']['flags']) and in_array('keinefahrtkaestchen',explode(';',$_wkeinst['meldezettel']['flags']))){
	$_fahrtkaestchen = false;
}
$_tmpl->assign('fahrtkaestchen',$_fahrtkaestchen);
$bearbeiten = !$flags['meldeschlussvorbei'];
$_tmpl->assign('bearbeiten',$bearbeiten);

if(!$bearbeiten or !isset($_GET['id']) or !ctype_digit($_GET['id'])){
	# Mitglieder holen
	$query = "SELECT t.id, mid, CONCAT(m.nachname,', ',m.vorname) as name, mw, t.teilnahme,
				 YEAR(gebdatum) as jg, t.fahrt, t.telefon, t.kommentar
				FROM ".DB_PREFIX."meldungen_teilnehmer as t, ".DB_PREFIX."mitglieder as m
				WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND t.mid = m.id
				ORDER BY m.nachname, m.vorname";
	$_db->holeDaten($query);
	if($_db->ergebnis['anzahl'] < 1){
		$_tmpl->assign('fehler','Es wurden noch keine Mitglieder gewählt');
	}
	else{
	$mitgldaten = $_db->ergebnis['daten'];
	$mids = $_db->baueArray('mid','#');

	# Trainingsgruppen holen
	$query = "SELECT mitgliedid as mid, kurz, bezeichnung as lang
				FROM ".DB_PREFIX."mitglieder_gruppen as mg LEFT JOIN ".DB_PREFIX."gruppen as g ON mg.gruppenid = g.id
				WHERE mitgliedid IN (".implode(',',$mids).")
				ORDER BY mitgliedid, g.sort";
	$_db->holeDaten($query);
	$mitglieder_trainingsgr = array();
	$trainingsgruppendaten = $_db->baueArray('*', '#');
	foreach($trainingsgruppendaten as $row){
		if(!isset($mitglieder_trainingsgr[$row['mid']])){
			$mitglieder_trainingsgr[$row['mid']] = array();
		}
		$mitglieder_trainingsgr[$row['mid']][] = $row;
	}

	# gemeldete Strecken
	$query = "SELECT w.id, wknr, laenge, disziplin, a.nr as abschnnr FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
				WHERE a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND a.id = w.abschnittid ORDER BY wknr";
	$_db->holeDaten($query);
	$strecken = array();
	foreach($_db->ergebnis['daten'] as $row){
		$strecken[$row['id']] = $row['laenge'].$_lagen[$row['disziplin']][0].'-'.($_SESSION['wk_abwickeln']['abschnitte']>1?$row['abschnnr'].'/':'').$row['wknr'];
	}
	$query = "SELECT mt.mid, ms.wkid FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."meldungen_starts as ms
				WHERE mt.mid IN (".implode(',',$mids).") AND mt.id = ms.teilnehmerid AND mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
				ORDER BY mid, wkid";
	$_db->holeDaten($query);
	$mitglieder_strecken = array();
	foreach($_db->ergebnis['daten'] as $row){
		if(!isset($mitglieder_strecken[$row['mid']])){
			$mitglieder_strecken[$row['mid']] = array();
		}
		$mitglieder_strecken[$row['mid']][] = $strecken[$row['wkid']];
	}

	# Abschnitte
	$query = "SELECT id, nr, IF(DATE_FORMAT(datum,'%w')=0,7,DATE_FORMAT(datum,'%w')) as wtag FROM ".DB_PREFIX."abschnitte
				WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." ORDER BY nr";
	$_db->holeDaten($query);
	$abschnitte = array();
	foreach($_db->ergebnis['daten'] as $row){
		$abschnitte[$row['id']] = $row['nr'].'/'.substr($_wochentage[$row['wtag']],0,2);
	}

	# Summen
	$summen = array();
	$summen['abschnitte'] = count($abschnitte);
	$query = "SELECT SUM(fahrt) as anz FROM ".DB_PREFIX."meldungen_teilnehmer
				WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND fahrt != -2 AND teilnahme != '-'";
	$_db->holeDaten($query);
	$summen['fahrt'] = $_db->holeWert();
	$summen['teiln'] = array('offen'=>0,'nimmtteil'=>0,'nicht'=>0);

	$mitglieder = array();
	foreach($mitgldaten as $row){
		# Trainingsgruppen
		$row['trainingsgr'] = '';
		if(isset($mitglieder_trainingsgr[$row['mid']])){
			$tmp = array();
			foreach($mitglieder_trainingsgr[$row['mid']] as $gr){
				$tmp[] = '<span title="'.$gr['lang'].'">'.$gr['kurz'].'</span>';
			}
			$row['trainingsgr'] = implode(', ', $tmp);
		}

		# Strecken
		$row['strecken'] = '';
		if(isset($mitglieder_strecken[$row['mid']])){
			$row['strecken'] = implode(', ',$mitglieder_strecken[$row['mid']]);
		}

		# Abschnittteilnahme
		$default = array();
		foreach($abschnitte as $a){
			$default[substr($a,0,-3)] = '0';
		}
		$tmp = $default;
		if($row['teilnahme'] == '0'){ # insgesamt noch unbekannt
			$summen['teiln']['offen']++;
			$row['_abschnteiln'] = $default;
		}
		elseif($row['teilnahme'] == '-'){ # nimmt insgesamt nicht teil
			$summen['teiln']['nicht']++;
			foreach($tmp as $key => $a){
				$tmp[$key] = '-';
			}
			$row['_abschnteiln'] = $tmp;
		}
		else{ # nimmt insgesamt teil, ermitteln ob ueberall
			$summen['teiln']['nimmtteil']++;
			$query = "SELECT ms.teilnahme, nr
						FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."meldungen_starts as ms,
						".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
						WHERE mt.mid = ".$row['mid']." AND mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND
						mt.id = ms.teilnehmerid AND ms.wkid=w.id AND w.abschnittid = a.id";
			$_db->holeDaten($query);
			$dat = $_db->ergebnis['daten'];
			$tmp2 = array();
			foreach($dat as $row2){
				if(!isset($tmp2[$row2['nr']])){
					$tmp2[$row2['nr']] = array();
				}
				$tmp2[$row2['nr']][] = $row2['teilnahme'];
			}
			foreach($tmp as $key => $a){
				if($a == '0'){
					$tmp[$key] = '*';
				}
			}
			foreach($tmp2 as $nr => $wert){
				if(in_array('0',$wert)){
					$tmp[$nr] = '0';
				}
				elseif(in_array('+',$wert) and in_array('-',$wert)){
					$tmp[$nr] = '/';
				}
				elseif(!in_array('+',$wert) and in_array('-',$wert)){
					$tmp[$nr] = '-';
				}
				elseif(in_array('+',$wert) and !in_array('-',$wert)){
					$tmp[$nr] = '+';
				}
			}
			$row['_abschnteiln'] = $tmp;
		}
		$mitglieder[$row['mid']] = $row;
	}

	if(isset($_POST['filter'])){
		if(!isset($_SESSION['wk_abwickeln']['ruecklaufzettel_filter'])){
			$_SESSION['wk_abwickeln']['ruecklaufzettel_filter'] = array();
		}
		$umsetzung = array(
			'offene'            => '0',
			'teilnehmende'      => '+',
			'nichtteilnehmende' => '-',
		);
		if($_POST['filter'] == 'keine'){
			unset($_SESSION['wk_abwickeln']['ruecklaufzettel_filter']);
		}
		elseif(isset($umsetzung[$_POST['filter']]) and count($_SESSION['wk_abwickeln']['ruecklaufzettel_filter']) < 2){
			$_SESSION['wk_abwickeln']['ruecklaufzettel_filter'][] = $umsetzung[$_POST['filter']];
			$_SESSION['wk_abwickeln']['ruecklaufzettel_filter'] = array_unique($_SESSION['wk_abwickeln']['ruecklaufzettel_filter']);
		}
	}

	if(isset($_SESSION['wk_abwickeln']['ruecklaufzettel_filter'])){
		$umsetzung = array(
			'0' => 'offene',
			'+' => 'teilnehmende',
			'-' => 'nicht teilnehmende',
		);
		$filter = $_SESSION['wk_abwickeln']['ruecklaufzettel_filter'];
		if(count($filter) == 1){
			$wert = $umsetzung[$filter[0]];
		}
		else{
			$wert = $umsetzung[$filter[0]].' und '.$umsetzung[$filter[1]];
		}
		$_tmpl->assign('filter','<em>ausgeblendete Mitglieder: '.$wert.'</em>');

		# nichtanzuzeigende Mitglieder filtern
		foreach($mitglieder as $key => $mitgl){
			if(in_array($mitgl['teilnahme'],$_SESSION['wk_abwickeln']['ruecklaufzettel_filter'])){
				unset($mitglieder[$key]);
			}
		}
	}

	# Anteil der offenen Teilnehmer ermitteln
	$ges = $summen['teiln']['offen']+$summen['teiln']['nimmtteil']+$summen['teiln']['nicht'];
	$summen['teiln']['prozentoffen'] = $summen['teiln']['offen']/$ges;
	$_tmpl->assign('abschnitte',$abschnitte);
	$_tmpl->assign('summen',$summen);
	$_tmpl->assign('mitglieder',$mitglieder);
	$_inh .= $_tmpl->fetch('wettkaempfe/42.ruecklaufzettel-uebersicht.inc.html');
	} # Ende des else für Prüfung auf gemeldete Mitglieder
}
else{ # Teilnehmer bearbeiten
	# Abschnitte des Wettkampfes
	$query = "SELECT id, nr, IF(DATE_FORMAT(datum,'%w')=0,7,DATE_FORMAT(datum,'%w')) as wtag FROM ".DB_PREFIX."abschnitte
				WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." ORDER BY nr";
	$_db->holeDaten($query);
	$dat = $_db->ergebnis['daten'];
	# Tage
	$tage = array();
	foreach($dat as $row){
		if(isset($tage[$row['wtag']])){
			continue;
		}
		$tage[$row['wtag']] = $_wochentage[$row['wtag']];
	}

	if(!isset($_POST['speichern'])){
		# Mitgliedsdaten
		$query = "SELECT t.id, mid, CONCAT(m.vorname,' ',m.nachname) as name, mw, t.teilnahme,
					YEAR(gebdatum) as jg, t.fahrt, t.telefon, t.kommentar
					FROM ".DB_PREFIX."meldungen_teilnehmer as t, ".DB_PREFIX."mitglieder as m
					WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND t.mid = m.id AND t.id = ".$_GET['id']."
					ORDER BY m.nachname, m.vorname";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] != 1){
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=ruecklaufzettel','Das Mitglied existiert nicht');
		}
		$mitglied = $_db->holeZeile();
		# Starts des Mitgliedes
		$query = "SELECT teilnahme, wkid, IF(DATE_FORMAT(a.datum,'%w')=0,7,DATE_FORMAT(a.datum,'%w')) as wtag
					FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
					WHERE teilnehmerid = ".$mitglied['id']." AND ms.wkid = w.id AND w.abschnittid = a.id";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] < 1){
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=ruecklaufzettel','Das Mitglied »'.$mitglied['name'].'« ist für keinen Wettkampf gemeldet');
		}
		$starts = $_db->ergebnis['daten'];
		$wkids = $_db->baueArray('wkid','#');
		$wtage = $_db->baueArray('wtag','#');

		$anz_starts = count($starts);
		$anz_ja = 0;
		$anz_offen = 0;
		$anz_nein = 0;
		$tmp = array();
		foreach($tage as $key => $t){
			$tmp[$key] = in_array($key,$wtage)?1:0;
		}
		foreach($starts as $row){
			switch($row['teilnahme']){
			case '-':
				$tmp[$row['wtag']] = 0;
				$anz_nein++;
				break;
			case '+':
				$anz_ja++;
				break;
			case '0':
				$tmp[$row['wtag']] = 0;
				$anz_offen++;
				break;
			}
		}
		$tmp['allet'] = 0;
		$tmp['wert'] = 0;
		if($anz_ja == $anz_starts){
			$tmp['wert'] = 'ja';
			$tmp['allet'] = 1;
		}
		elseif($anz_nein == $anz_starts){
			$tmp['wert'] = 'nein';
		}
		elseif($anz_offen == $anz_starts){
			$tmp['wert'] = 'offen';
		}
		$mitglied['_teiln'] = $tmp;
		unset($tmp);
	}
	else{
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		# Fahrt zusammenbauen
		if($_fahrtkaestchen){
			$_POST['daten']['fahrt'] = -2;
			if(isset($_POST['f']['wahl'])){
				if($_POST['f']['wahl']=='mitf'){
					$_POST['daten']['fahrt'] = -1;
				}
				if($_POST['f']['wahl']=='selbst'){
					if(isset($_POST['f']['plaetze']) and preg_match('~^[0-9]{1,2}$~',$_POST['f']['plaetze'])){
						$_POST['daten']['fahrt'] = $_POST['f']['plaetze'];
					}
					elseif(isset($_POST['f']['plaetze']) and !empty($_POST['f']['plaetze']) and !preg_match('~^[0-9]{1,2}$~',$_POST['f']['plaetze'])){
						$f .= 'Die Anzahl der Plätze ist ungültig<br />';
						$_POST['daten']['fahrt'] = $_POST['f']['plaetze'];
					}
					else{
						$_POST['daten']['fahrt'] = '0';
					}
				}
			}
			if($_POST['daten']['fahrt'] == -2){
				$f .= 'Der Wert für die Fahrt fehlt<br />';
			}
		}
		# Telefon ermitteln
		#  daten[telefonvorhanden]
		if(isset($_POST['daten']['telefon']) and !empty($_POST['daten']['telefon'])){
			$tmp = pruefen($_POST['daten']['telefon'],'telefon','Die Telefonnummer ist ungültig',$_gleinst['seitenweit']['standardvorwahl']);
			if(!empty($tmp)){
				$f .= $tmp;
			}
		}
		elseif(isset($_POST['daten']['telefonvorhanden']) and $_POST['daten']['telefonvorhanden'] != '-'){
			$_POST['daten']['telefon'] = $_POST['daten']['telefonvorhanden'];
			$tmp = pruefen($_POST['daten']['telefon'],'telefon','Die Telefonnummer ist ungültig',$_gleinst['seitenweit']['standardvorwahl']);
			if(!empty($tmp)){
				$f .= $tmp;
			}
		}

		$f .= pruefen($_POST['daten']['kommentar'],'maxlaenge','Der Kommentar ist zu lang (max. 200 Zeichen)',200);
		if(empty($f)){
			$pruefenflagsetzen = false;
			if(!isset($_POST['daten']['_teiln']['wert'])){
				$_POST['daten']['_teiln']['wert'] = '';
			}
			if($_POST['daten']['_teiln']['wert']=='offen' or count($_POST['daten']['_teiln']) == 1){
				$pruefenflagsetzen = true;
				$query = "UPDATE ".DB_PREFIX."meldungen_starts SET teilnahme = '0' WHERE teilnehmerid = ".$_GET['id'];
				$grundt = '0';
				$_db->fuehreQueryAus($query);
			}
			elseif($_POST['daten']['_teiln']['wert']=='ja'){
				$pruefenflagsetzen = true;
				$query = "UPDATE ".DB_PREFIX."meldungen_starts SET teilnahme = '+' WHERE teilnehmerid = ".$_GET['id'];
				$grundt = '+';
				$_db->fuehreQueryAus($query);
			}
			elseif($_POST['daten']['_teiln']['wert']=='nein'){
				$query = "UPDATE ".DB_PREFIX."meldungen_starts SET teilnahme = '-' WHERE teilnehmerid = ".$_GET['id'];
				$grundt = '-';
				$_db->fuehreQueryAus($query);
			}
			else{
				$query = "SELECT wkid, IF(DATE_FORMAT(a.datum,'%w')=0,7,DATE_FORMAT(a.datum,'%w')) as wtag
							FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
							WHERE teilnehmerid = ".$_GET['id']." AND ms.wkid = w.id AND w.abschnittid = a.id";
				$_db->holeDaten($query);
				$umsetzarray = $_db->baueArray('wtag','wkid');
				$teilntage = array();
				foreach($tage as $key => $tag){
					if(in_array($key,array_keys($_POST['daten']['_teiln']))){
						$teilntage[] = $key;
					}
				}
				$teiln_ja = array();
				$teiln_nein = array();
				foreach($umsetzarray as $id => $wtag){
					if(in_array($wtag,$teilntage)){
						$teiln_ja[] = $id;
					}
					else{
						$teiln_nein[] = $id;
					}
				}
				if(count($teiln_nein) > 0){
					$grundt = '-';
					$query = "UPDATE ".DB_PREFIX."meldungen_starts SET teilnahme = '-'
								WHERE teilnehmerid = ".$_GET['id']." AND wkid IN (".implode(',',$teiln_nein).")";
					$_db->fuehreQueryAus($query);
				}
				if(count($teiln_ja) > 0){
					$pruefenflagsetzen = true;
					$grundt = '+';
					$query = "UPDATE ".DB_PREFIX."meldungen_starts SET teilnahme = '+'
								WHERE teilnehmerid = ".$_GET['id']." AND wkid IN (".implode(',',$teiln_ja).")";
					$_db->fuehreQueryAus($query);
				}
			}
			$query = "UPDATE ".DB_PREFIX."meldungen_teilnehmer SET
						".($_fahrtkaestchen?"fahrt = '".$_POST['daten']['fahrt']."',":'')." teilnahme = '".$grundt."',
						telefon = '".$_POST['daten']['telefon']."', kommentar = '".$_POST['daten']['kommentar']."'
						WHERE id = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			$_wkeinst['flags']['pflichtzeitengeprueft'] = 0;
			schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=ruecklaufzettel','Die Meldung des Mitgliedes wurde gespeichert');
		}
		else{
			$_tmpl->assign('fehler',$f);
			$mitglied = $_POST['daten'];
		}
	}
	# Telefonnummern des Mitgliedes
	$query = "SELECT id, CONCAT(vorwahl,'/',nummer) as tel FROM ".DB_PREFIX."telefon WHERE mitgliedid = ".$mitglied['mid'];
	$_db->holeDaten($query);
	$_tmpl->assign('telnummern',$_db->baueArray('tel','tel'));
	$_tmpl->assign('m',$mitglied);
	$_tmpl->assign('tage',$tage);
	$_tmpl->tk_javascriptzuweisen('inline',"function platz(e){
  if(e.value != ''){
    e.form.elements['f[wahl]'][0].checked = true;
  }
}
function fahrt(e){
  if(e.checked && e.form.elements['f[wahl]'][1]){
    e.form.elements['f[wahl]'][1].checked = true;
  }
}");
	$_inh .= $_tmpl->fetch('wettkaempfe/42.ruecklaufzettel-teilnehmer.inc.html');
}
# EOF
