<?php
function erzeugeDsv6Datei($daten, $wettkampf, $verein = false){
	global $_lagen, $_gleinst;
	$verein = $verein===false?TKSWIM_VEREIN:$verein;
	
	$br = "\r\n"; # PHP_EOL geht nicht, da SAM die erzeugten Dateien sonst nicht einlesen kann
	$datinh = '(* Stand: '.date('d.m.Y, H:i').' *)'.$br;
	$datinh .= '(* generiert von: tkswim '.TKSWIM_VERSION.' (->https://tkswim.de/) *)'.$br;
	$datinh .= 'FORMAT:Vereinsmeldeliste;6;'.$br;
	$datinh .= 'ERZEUGER:tkswim;'.TKSWIM_VERSION.';info@tkswim.de;'.$br;
	$datinh .= 'VERANSTALTUNG:'.$wettkampf['titel'].';'.$wettkampf['ort'].';'.$wettkampf['bahnlaenge'].';HANDZEIT;'.$br;
	foreach($daten['abschnitte'] as $row){
		$datinh .= 'ABSCHNITT:'.$row['nr'].';'.$row['datum'].';'.$row['uhrzeit'].';;'.$br;
	}
	foreach($daten['wettkaempfe'] as $row){
		# WK-Nummer, WK-Art, Abschnitt
		$datinh .= 'WETTKAMPF:'.$row['wknr'].';'.($row['wkart']=='v'?'V':'E').';'.$row['nr'].';';
		# Anzahl Starter, Streckenlänge
		if(strpos($row['laenge'],'x') != false){
			$datinh .= str_replace('x',';',$row['laenge']).';';
		}
		else{
			$datinh .= ';'.$row['laenge'].';';
		}
		# Disziplin, Ausübung
		$datinh .=($row['disziplin']==6?'X':$_lagen[$row['disziplin']][0]).';'.($row['disziplin']==6?'X':'GL').';';
		# Geschlecht, Qualifikations-WK
		$datinh .= $row['mw'].';;;'.$br;
	}
	$datinh .= 'VEREIN:'.$verein.';'.TKSWIM_VEREINSID.';'.TKSWIM_LSVKENNZIFFER.';GER;'.$br;
	$a = &$daten['ansprechpartner'];
	if($daten['ansprechpartner'] === false){
		$datinh .= 'ANSPRECHPARTNER:-;;;;GER;;;-;'.$br;
	}
	else{
		$a = &$daten['ansprechpartner'];
		$datinh .= 'ANSPRECHPARTNER:'.$a['name'].';'.$a['strasse'].';'.$a['plz'].';';
		$datinh .= $a['ort'].';GER;'.$a['tel'].';'.$a['fax'].';'.$a['email'].';'.$br;
	}

	if($daten['kampfrichter'] !== false){
		$i = 1;
		foreach($daten['kampfrichter'] as $kariid => $kari){
			$abschn = array();
			$kari['gruppe'] = $kari['gruppe'][2]==1?'SCH':($kari['gruppe'][1]==1?'AUS':'WKR');
			$datinh .= 'KARIMELDUNG:'.$i.';'.$kari['name'].';'.$kari['gruppe'].';'.$br;
			if(isset($kari['abschnitte'])){
				foreach($kari['abschnitte'] as $a){
					$abschn[] = $daten['abschnitte'][$a]['nr'];
				}
			}
			else{
				foreach($daten['abschnitte'] as $a){
					$abschn[] = $a['nr'];
				}				
			}
			foreach($abschn as $a){
				$datinh .= 'KARIABSCHNITT:'.$i.';'.$a.';;'.$br;
			}
			$i++;
		}
	}

	$i = 1;
	foreach($daten['einzelstarts'] as $m){
		if(!isset($m['_starts'])){
			continue;
		}
		$datinh .= 'PNMELDUNG:'.$m['name'].';'.(empty($m['dsvid'])?'0':$m['dsvid']).';'.$i.';'.$m['mw'].';'.$m['jg'].';;;'.$br;
		foreach($m['_starts'] as $wk){
			$datinh .= 'STARTPN:'.$i.';'.$wk['wknr'].';'.(is_null($wk['zeit'])?'':'00:'.text_format($wk['zeit'],'schwimmzeit')).';'.$br;
		}
		$i++;
	}
	
	foreach($daten['staffelstarts'] as $s){
		$datinh .= 'STMELDUNG:'.$s['nr'].';'.$i.';;0;;'.$s['klasse'].';'.$br;
		$datinh .= 'STARTST:'.$i.';'.$s['wknr'].';'.(empty($s['zeit'])?'':'00:'.text_format($s['zeit'], 'schwimmzeit')).';'.$br;
		$i++;
	}
	$datinh .= 'DATEIENDE';
	# ab DSV6 müssen die Inhalte UTF-8-kodiert sein
	#$datinh = utf8_decode($datinh);
	return $datinh;
}
# EOF
