<?php
# relevante Teile der _start.inc.php
require_once('./__inc/conf/conf.inc.php');
date_default_timezone_set('Europe/Berlin');

# Einstellungen, Klassen und Funktionen laden
require_once(PFAD_INCLUDE.'class/db.inc.php');
require_once(PFAD_INCLUDE.'func/text_format.inc.php');
require_once(PFAD_INCLUDE.'func/prueferechte.inc.php');

ini_set('session.use_only_cookies', 1);
ini_set('session.use_trans_sid', 0);
ini_set('session.name', 'TKSWIMSESSIONID');
session_start();
# Ende _start.inc.php

# bei manchen Aktionen wird eine Datenbankverbindung benötigt
$aktionenmitdb = array(
	'gruppen_mitgliedverschieben',
	'gruppen_mitgliedkopieren',
	'gruppen_mitgliedeinfuegen',
	'loeschen',
	'alteadressespeichern',
	'plzortergaenzen',
	'familieanlegen',
	'mitgliedsuchen',
	'sortieren'
);
# manche Aktionen müssen per GET aufgerufen werden
$aktionenperget = array(
	'mitgliedsuchen'
);
if(isset($_GET['aktion']) and in_array($_GET['aktion'], $aktionenperget)){
	$_POST = $_GET;
}

if(!isset($_POST['aktion'])){
	exit;
}

if(in_array($_POST['aktion'], $aktionenmitdb)){
	# Datenbankklasse starten und Verbindung oeffnen
	$_inh = '';
	$_db = new db;
	$_db->tmpl = &$_tmpl;
	$_db->schreibschutz = TKSWIM_SCHREIBSCHUTZ;
	if(TKSWIM_SCHREIBSCHUTZ){
		echo 0;
		exit;
	}
	$_db->setzeDbParameter();
	$_db->verbindeMitDb();
	function dbgeaendert(){
		global $_db;
		$_db->speichereGeaenderteTabellen();
	}
}

switch($_POST['aktion']){
case 'sortieren':
	$arten = array(
		'gruppen'       => array('tabelle' => 'gruppen',       'recht' => 'tr_gruppen_bearbeiten'),
		'trainingsorte' => array('tabelle' => 'trainingsorte', 'recht' => 'tr_trainingsorte_bearbeiten'),
		'pflichtzeiten' => array('tabelle' => 'pflichtzeiten', 'recht' => 'w_pflichtzeiten_bearbeiten'),
		'rechtegruppen' => array('tabelle' => 'rechtegruppen', 'recht' => 'a_rechtegruppen_bearbeiten'),
		'tags'          => array('tabelle' => 'tags',          'recht' => 'tr_tags_bearbeiten'),
		'vorstand'      => array('tabelle' => 'vorstand',      'recht' => 'm_vorstand_bearbeiten')
	);
	if(!isset($_POST['art']) or !array_key_exists($_POST['art'], $arten)){
		echo -1; # keine oder ungültige Art übergeben
		exit;
	}
	if(!pruefeRechte($arten[$_POST['art']]['recht'])){
		echo -2; # kein Recht
		exit;
	}
	if(!isset($_POST['ids']) or !is_array($_POST['ids'])){
		echo -3; # keine IDs übergeben
		exit;
	}
	$query = "UPDATE ".DB_PREFIX.$arten[$_POST['art']]['tabelle']." SET sort = %s WHERE id = '%s'";
	$sort = 1;
	foreach($_POST['ids'] as $id){
		$_db->fuehreQueryAus(sprintf($query, $sort, substr($id, 1)));
		$sort++;		
	}
	echo 1; # die Änderungen wurden gespeichert
	exit;

case 'loeschen':
	function ergebnismeldung($status){
		/*
		Statusmeldungen:
		1: Die Daten wurden gelöscht -> Zeile entfernen
		-1: fehlende Rechte
		-2: Schreibschutz gesetzt
		-3: Parameter fehlt oder ungültig
		*/
		if($status == 1){
			dbgeaendert();
		}
		header('Content-Type: text/plain');
		echo $status;
		exit;
	}
	if(TKSWIM_SCHREIBSCHUTZ){
		ergebnismeldung(-2);
	}

	$noetigerechte = array(
		'mitglied_gruppe'           => 'tr_gruppen_mitglieder_bearbeiten',
		'telefonnummer'             => 'm_aendern',
		'logindaten'                => 'm_logins',
		'kampfrichter'              => 'm_kampfrichter_bearbeiten',
		'rechtegruppe'              => 'a_rechtegruppen_bearbeiten',
		'familien'                  => 'm_familien_bearbeiten',
		'vorstand'                  => 'm_vorstand_bearbeiten',
		'termine'                   => 's_kalender_terminebearbeiten',
		'lizenzbeantragtflag'       => 'w_lizenzen_bearbeiten',
		'wkabw_startentfernen'      => 'w_abwickeln_mitglhinzufuegen',
		'wkabw_teilnehmerentfernen' => 'w_abwickeln_mitglhinzufuegen',
	);

	if(!array_key_exists($_POST['art'], $noetigerechte)){
		# die Art was gelöscht werden soll existiert nicht
		ergebnismeldung(-3);
	}
	if(!pruefeRechte($noetigerechte[$_POST['art']])){
		# die Rechte für die Löschaktion fehlen
		ergebnismeldung(-1);
	}

	# Bei diesen Arten muss die zusatzid gesetzt sein, bei den anderen reicht die id alleine
	$artenmitzusatzid = array('mitglied_gruppe');
	if(!isset($_POST['id'])){
		ergebnismeldung(-3);
	}
	if(in_array($_POST['art'], $artenmitzusatzid) and !isset($_POST['zusatzid'])){
		ergebnismeldung(-3);
	}

	switch($_POST['art']){
	case 'lizenzbeantragtflag':
		$query = "DELETE FROM ".DB_PREFIX."eigenschaften
					WHERE art = 'm' AND eigenschaft = 'dsvidbeantragt' AND artid = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		ergebnismeldung((($_db->holeAnzahl()<1)?-3:1));
	case 'vorstand':
		if($_POST['id'] < 10){ # Vorstandsämter mit ID < 10 können nicht gelöscht werden
			ergebnismeldung(-3);
		}
		# zugewiesenes Mitglied holen um diesem ggf. die Rechte an der Vorstandsrechtegruppe entziehen zu können
		$query = "SELECT mitgliedid FROM ".DB_PREFIX."vorstand WHERE id = '".text_format($_POST['id'],'db')."'";
		$_db->holeDaten($query);
		$mid = $_db->holeWert();
		if(!is_null($mid)){			
			$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid." AND rechtegrid = 4";
			$_db->fuehreQueryAus($query);
		}
		$query = "DELETE FROM ".DB_PREFIX."vorstand WHERE id = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		ergebnismeldung((($_db->holeAnzahl()<1)?-3:1));
	case 'familien':
		$query = "SELECT familienid FROM ".DB_PREFIX."mitglieder WHERE familienid = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		if($_db->holeAnzahl() > 0){ # Es sind noch Verknüpfungen zu Mitgliedern da
			ergebnismeldung(-3);
		}
		$query = "DELETE FROM ".DB_PREFIX."familien WHERE id = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		ergebnismeldung((($_db->holeAnzahl()<1)?-3:1));
	case 'rechtegruppe':
		if($_POST['id'] < 10){ # Es können nur Rechtegruppen >= 10 gelöscht werden
			ergebnismeldung(-3);
		}
		$query = "SELECT rechtegrid FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechtegrid = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		$anz1 = $_db->holeAnzahl();
		$query = "SELECT rechtegrid FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE rechtegrid = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		$anz2= $_db->holeAnzahl();
		if($anz1 > 0 or $anz2 > 0){ # Es sind noch Verknüpfungen auf die Rechtegruppe da
			ergebnismeldung(-3);
		}
		$query = "DELETE FROM ".DB_PREFIX."rechtegruppen WHERE id = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		ergebnismeldung((($_db->holeAnzahl()<1)?-3:1));
	case 'mitglied_gruppe':
		$query = "DELETE FROM ".DB_PREFIX."mitglieder_gruppen
					WHERE gruppenid = '".text_format($_POST['zusatzid'],'db')."' AND mitgliedid = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		$anz = $_db->holeAnzahl();
		require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
		mitglieder_rechtegruppensetzen($_POST['id']);
		ergebnismeldung((($anz<1)?-3:1));
	case 'wkabw_startentfernen':
		list($tid,$wkid) = explode('_',$_POST['id']);
		$query = "DELETE FROM ".DB_PREFIX."meldungen_starts
					WHERE teilnehmerid = '".text_format($tid,'db')."' AND wkid = '".text_format($wkid,'db')."'";	
		$_db->fuehreQueryAus($query);
		ergebnismeldung((($_db->holeAnzahl()<1)?-3:1));
	case 'wkabw_teilnehmerentfernen':
		$query = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		$query = "DELETE FROM ".DB_PREFIX."meldungen_teilnehmer WHERE id = '".text_format($_POST['id'],'db')."'";	
		$_db->fuehreQueryAus($query);
		ergebnismeldung((($_db->holeAnzahl()<1)?-3:1));
	case 'telefonnummer':
	case 'logindaten':
	case 'kampfrichter':
	case 'termine':
		$art2tabelle = array(
			'telefonnummer' => 'telefon',
			'logindaten'    => 'logins',
			'kampfrichter'  => 'kampfrichter',
			'termine'       => 'termine'
		);
		$query = "DELETE FROM ".DB_PREFIX.$art2tabelle[$_POST['art']]." WHERE id = '".text_format($_POST['id'],'db')."'";
		$_db->fuehreQueryAus($query);
        $anz = $_db->holeAnzahl();
		if($_POST['art'] == 'kampfrichter'){
			require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
			mitglieder_rechtegruppensetzen($_POST['id']);
		}
		ergebnismeldung((($anz < 1) ? -3 : 1));
	default:
		break;
	}
	break;

case 'mitgliedsuchen':
	if(!pruefeRechte('m_anzeigen_name')){
		exit;
	}
	$q = text_format($_GET['term'], 'db');
	$ausgetr = (isset($_GET['ausgetretene']) and $_GET['ausgetretene']);
	$query = "SELECT vorname, nachname, mw, YEAR(gebdatum) as jg, id
				FROM ".DB_PREFIX."mitglieder
				WHERE (vorname LIKE '%".$q."%' or nachname LIKE '%".$q."%') ".($ausgetr?'':'AND ausgetreten IS NULL')."
				ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$dbdaten = $_db->baueArray('*', 'id');
	$daten = array();
	foreach($dbdaten as $id => $row){
		switch($_GET['format']){
		case 'vnmj': $daten[$id] = $row['vorname'].' '.$row['nachname'].' ('.$row['mw'].', '.$row['jg'].')'; break;
		case 'nvmj': $daten[$id] = $row['nachname'].', '.$row['vorname'].' ('.$row['mw'].', '.$row['jg'].')'; break;
		case 'nv':   $daten[$id] = $row['nachname'].', '.$row['vorname']; break;
		default:     $daten[$id] = $row['vorname'].' '.$row['nachname']; break;
		}
	}
	$ausg = array();
	foreach($daten as $id => $name){
		$ausg[] = '{"id":"'.$id.'", "label":"'.$name.'"}';
	}
	echo '['.implode(',',$ausg).']';
	break;	

case 'gruppen_mitgliedeinfuegen':
	function ergebnismeldung($code, $optionen = array()){
		$statusmeldungen = array(
			'+1' => '%s wurde der Gruppe %s hinzugefügt.',
			'-1' => 'Dir fehlen die Rechte um Mitglieder hinzufügen zu dürfen.',
			'-2' => '%s ist bereits in der Gruppe %s eingetragen.',
			'-3' => 'Das zu verschiebende Mitglied oder die Gruppe wurde nicht angegeben.',
			'-4' => 'Das Mitglied wurde nicht gefunden.',
			'-5' => 'Die Gruppe wurde nicht gefunden.',
			'-6' => 'Der Schreibschutz für alle Daten ist gesetzt, es können momentan keine Daten verandert werden.'
		);
		if(in_array($code, array('+1','-2'))){
			$meldung = sprintf($statusmeldungen[$code], $optionen['mitglied'], $optionen['gruppe']);
		}
		else{
			$meldung = $statusmeldungen[$code];
		}
		if($code == '+1'){
			dbgeaendert();
			$ausgabe = $code."\n".$meldung."\n".$optionen['mid']."\n".$optionen['einhaengennach']."\n";
			$ausgabe .= '<tr id="r'.$optionen['mid'].'"><td><span id="m'.$optionen['mid'].'"><a href="'.ROOT.'/'.(TKSWIM_KURZLINKS?'m':'mitglieder/anzeigen'.TKSWIM_DATEIENDUNG.'?id=').$optionen['mid'].'" id="t'.$optionen['mid'].'">'.$optionen['nameliste'].'</a> ('.$optionen['mjg'].')</span></td><td><span id="v'.$optionen['mid'].'"><a href="'.ROOT.'/training/mitglieder'.TKSWIM_DATEIENDUNG.'?aktion=verschieben&amp;grid='.$optionen['gid'].'&amp;id='.$optionen['mid'].'">verschieben</a></span> <a href="'.ROOT.'/training/mitglieder'.TKSWIM_DATEIENDUNG.'?aktion=loeschen&amp;grid='.$optionen['gid'].'&amp;id='.$optionen['mid'].'" class="loeschen">löschen</a></td></tr>';
		}
		else{
			$ausgabe = $code."\n".$meldung;
		}
		header('Content-Type: text/plain');
		echo $ausgabe;
		exit;
	}
	if(TKSWIM_SCHREIBSCHUTZ){
		ergebnismeldung('-6');
	}
	if(!pruefeRechte('tr_gruppen_mitglieder_bearbeiten')){
		ergebnismeldung('-1');
	}
	if(!isset($_POST['mid']) or !isset($_POST['gruppe'])){
		ergebnismeldung('-3');
	}
	# Gruppe suchen
	$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."gruppen WHERE id = '".text_format($_POST['gruppe'],'db')."'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()!=1){
		ergebnismeldung('-5');
	}
	$gruppe = $_db->holeZeile();
	# Mitglied suchen
	$query = "SELECT id, CONCAT(vorname, ' ', nachname) as name, CONCAT(nachname, ', ', vorname) as nameliste, YEAR(gebdatum) as jg
				FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_POST['mid'],'db')."'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()!=1){
		ergebnismeldung('-4');
	}
	$mitglied = $_db->holeZeile();


	# Mitglied schon in der Gruppe eingetragen?
	$query = "SELECT mitgliedid FROM ".DB_PREFIX."mitglieder_gruppen
				WHERE mitgliedid = ".$mitglied['id']." AND gruppenid = ".$gruppe['id'];
	$_db->holeDaten($query);
	$optionen = array(
		'mitglied'  => $mitglied['name'],
		'nameliste' => $mitglied['nameliste'],
		'mid'       => $mitglied['id'],
		'mjg'       => $mitglied['jg'],
		'gruppe'    => $gruppe['bezeichnung'],
		'gid'       => $gruppe['id']
	);
	if($_db->holeAnzahl() != 0){
		ergebnismeldung('-2', $optionen);
	}
	$query = "INSERT INTO ".DB_PREFIX."mitglieder_gruppen (gruppenid, mitgliedid)
				VALUES (".$gruppe['id'].", ".$mitglied['id'].")";
	$_db->fuehreQueryAus($query);
	require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
	mitglieder_rechtegruppensetzen($mitglied['id']);

	# ermitteln wo das Mitglied eingehängt werden muss
	$query = "SELECT id FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."mitglieder_gruppen as mt ON m.id=mt.mitgliedid
				WHERE mt.gruppenid = ".$gruppe['id']." ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$ids = $_db->baueArray('id', '#');
	$nach = -1;
	foreach($ids as $key => $id){
		if($id != $mitglied['id']){
			continue;
		}
		if($key > 0){
			$nach = $ids[$key-1];
		}
		break;
	}
	$optionen['einhaengennach'] = $nach;
	ergebnismeldung('+1', $optionen);
	break;

case 'gruppen_mitgliedverschieben':
case 'gruppen_mitgliedkopieren':
	$kv = $_POST['aktion']=='gruppen_mitgliedverschieben'?'v':'k';
	function ergebnismeldung($code, $optionen = array()){
		global $kv;
		$statusmeldungen = array(
			1 => '%s wurde in die Gruppe %s verschoben.',
			2 => '%s wurde aus der Gruppe %s gelöscht.',
			3 => '%s wurde in die Gruppe %s kopiert.',
			-1 => 'Dir fehlen die Rechte um Mitglieder '.($kv=='v'?'verschieben':'kopieren').' zu dürfen.',
			-2 => '%s ist bereits in der Gruppe %s eingetragen.',
			-3 => 'Das zu verschiebende Mitglied, die Ursprungs oder die Zielgruppe wurde nicht angegeben.',
			-4 => 'Das Mitglied wurde nicht gefunden.',
			-5 => 'Die Ursprungsgruppe wurde nicht gefunden.',
			-6 => 'Die Zielgruppe wurde nicht gefunden.',
			-7 => 'Das Mitglied existiert in der Ursprungsgruppe nicht.',
			-8 => 'Der Schreibschutz für alle Daten ist gesetzt, es können momentan keine Daten verandert werden.'
		);
		if(in_array($code, array(1,2,3,-2))){
			$meldung = sprintf($statusmeldungen[$code], $optionen['mitglied'], $optionen['gruppe']);
		}
		else{
			$meldung = $statusmeldungen[$code];
		}
		if($code > 0){
			dbgeaendert();
		}
		$ausgabe = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
		$ausgabe .= '<ergebnis>'."\n";
		$ausgabe .= ' <code>'.$code.'</code>'."\n";
		$ausgabe .= ' <meldung>'.text_format($meldung,'xml').'</meldung>'."\n";
		$ausgabe .= '</ergebnis>'."\n";
		header('Content-Type: text/xml');
		echo $ausgabe;
		exit;
	}
	if(TKSWIM_SCHREIBSCHUTZ){
		ergebnismeldung(-8);
	}
	if(!pruefeRechte('tr_gruppen_mitglieder_bearbeiten')){
		ergebnismeldung(-1);
	}
	if(!isset($_POST['mid']) or !isset($_POST['gralt']) or !isset($_POST['grneu'])){
		ergebnismeldung(-3);
	}
	# Ursprungsgruppe suchen
	$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."gruppen WHERE id = '".text_format($_POST['gralt'],'db')."'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()!=1){
		ergebnismeldung(-5);
	}
	$gruppealt = $_db->holeZeile();
	if($_POST['grneu'] != 'l'){
		# Zielgruppe suchen
		$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."gruppen WHERE id = '".text_format($_POST['grneu'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl()!=1){
			ergebnismeldung(-6);
		}
		$gruppeneu = $_db->holeZeile();
	}
	# Mitglied suchen
	$query = "SELECT id, CONCAT(vorname, ' ', nachname) as name
				FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_POST['mid'],'db')."'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()!=1){
		ergebnismeldung(-4);
	}
	$mitglied = $_db->holeZeile();
	if($_POST['grneu'] == 'l'){
		$query = "DELETE FROM ".DB_PREFIX."mitglieder_gruppen
					WHERE gruppenid = ".$gruppealt['id']." AND mitgliedid = ".$mitglied['id'];
		$_db->fuehreQueryAus($query);
		if($_db->holeAnzahl()<1){
			ergebnismeldung(-7);
		}
		require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
		mitglieder_rechtegruppensetzen($mitglied['id']);
		$optionen = array(
			'mitglied' => $mitglied['name'],
			'gruppe'   => $gruppealt['bezeichnung']
		);
		ergebnismeldung(2, $optionen);
	}
	else{
		# Mitglied schon in der Gruppe eingetragen?
		$query = "SELECT mitgliedid FROM ".DB_PREFIX."mitglieder_gruppen
					WHERE mitgliedid = ".$mitglied['id']." AND gruppenid = ".$gruppeneu['id']."";
		$_db->holeDaten($query);
		$optionen = array(
			'mitglied' => $mitglied['name'],
			'gruppe'   => $gruppeneu['bezeichnung']
		);
		if($_db->holeAnzahl() != 0){
			ergebnismeldung(-2, $optionen);
		}
		if($kv=='v'){
			$query = "UPDATE ".DB_PREFIX."mitglieder_gruppen SET gruppenid = ".$gruppeneu['id']."
						WHERE gruppenid = ".$gruppealt['id']." AND mitgliedid = ".$mitglied['id'];
			$code = 1;
		}
		else{
			$query = "INSERT INTO ".DB_PREFIX."mitglieder_gruppen
						SET gruppenid = ".$gruppeneu['id'].", mitgliedid = ".$mitglied['id'];
			$code = 3;
		}			
		$_db->fuehreQueryAus($query);
		if($_db->holeAnzahl()<1){
			ergebnismeldung(-7);
		}		
		require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
		mitglieder_rechtegruppensetzen($mitglied['id']);

		ergebnismeldung($code, $optionen);
	}

case 'dbverbindungtesten':
	function ergebnismeldung($fehler, $meldung){
/* 		$ausgabe = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
		$ausgabe .= '<ergebnis>'."\n";
		$ausgabe .= ' <erfolg>'.($fehler?0:1).'</erfolg>'."\n";
		$ausgabe .= ' <meldung>'.text_format($meldung,'xml').'</meldung>'."\n";
		$ausgabe .= '</ergebnis>';
		file_put_contents('tmp.txt',$ausgabe);
		header('Content-Type: text/xml'); */
		$daten = [
			'erfolg' => ($fehler?0:1),
			'meldung' => $meldung,
		];
		$daten = json_encode($daten);
		header("Content-type:application/json");
		echo $daten;
		#file_put_contents('tmp.txt',$daten);
		


		
		exit;

	}
	if(!isset($_SESSION['adminlogin'])){
		ergebnismeldung(true, 'keine Rechte');
		break;
	}
	$eralt = error_reporting(0);
	$fehler = false;

	if(!function_exists('mysqli_connect')){
		$fehler = true;
		$meldung = 'Die MySQLi-Erweiterung ist nicht installiert.';
	}
	else{
		$conn = mysqli_connect($_POST['server'], $_POST['benutzername'], $_POST['passwort'], $_POST['name']);
		if($conn === false){
			$fehler = true;
			$meldung = 'MySQLi hat folgenden Fehler gemeldet: '.mysqli_connect_error();
		}
		else{			
			$meldung = 'Es wurde erfolgreich mit der Datenbank verbunden.';
		}
	}
	error_reporting($eralt);
	ergebnismeldung($fehler, $meldung);
	break;

case 'alteadressespeichern':
	header('Content-Type: text/plain');
	if(!pruefeRechte('m_aendern') or TKSWIM_SCHREIBSCHUTZ){
		echo 0;
		break;
	}
	$query = "SELECT id, strasse, hausnr, plz, ort FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_POST['mid'],'db')."'";
	$_db->holeDaten($query);
	if($_db->ergebnis['anzahl'] != 1){
		echo 0;
		break;
	}
	$row = $_db->holeZeile();
	$alteadresse = $row['strasse'].' '.$row['hausnr'].'|'.$row['plz'].' '.$row['ort'];
	# Datensatz bereits vorhanden?
	$query = "SELECT wert FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND artid = ".$row['id']." AND eigenschaft = 'alteadresse'";
	$_db->holeDaten($query);
	if($_db->ergebnis['anzahl'] == 0){ # kein Datensatz vorhanden -> anlegen
		$query = "INSERT INTO ".DB_PREFIX."eigenschaften (art, artid, eigenschaft, wert)
					VALUES ('m', ".$row['id'].", 'alteadresse', '".text_format($alteadresse,'db')."')";
	}
	else{ # Datensatz vorhanden -> aendern
		$query = "UPDATE ".DB_PREFIX."eigenschaften SET wert = '".text_format($alteadresse,'db')."'
					WHERE art = 'm' AND artid = ".$row['id']." AND eigenschaft = 'alteadresse'";
	}
	$_db->fuehreQueryAus($query);
	dbgeaendert();
	echo 1;
	break;

case 'plzortergaenzen':
	$ausgabe = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
	$str = isset($_POST['str'])?trim($_POST['str']):'';
	$ort = isset($_POST['ort'])?trim($_POST['ort']):'';
	$plz = isset($_POST['plz'])?trim($_POST['plz']):'';
	function strassensort($a, $b){
		if($a['strasse'] == $b['strasse']){
			return ($a['ort'] < $b['ort']) ? -1 : 1;
		}
		return ($a['strasse'] < $b['strasse']) ? -1 : 1;
	}
	function anzsort($a, $b){
		if($a['anz'] == $b['anz']){
			return ($a['ort'] < $b['ort']) ? -1 : 1;
		}
		return ($a['anz'] < $b['anz']) ? 1 : -1;
	}

	$ausgabe .= '<ergebnis>'."\n";
	if(empty($ort) and empty($str) and empty($plz)){
		$ausgabe .= ' <fehler reaktionsart="alert">Es muss mindestens eines der Felder Straße, Ort und PLZ (teil)ausgefüllt sein.</fehler>'."\n";
	}
	else{
		# Daten ohne Strasse
		if(!empty($ort) or !empty($plz)){
			$where = array();
			if(!empty($ort)){
				$where[] = "ort LIKE '".text_format($ort,'db')."%'";
			}
			if(!empty($plz)){
				$where[] = "plz LIKE '".text_format($plz,'db')."%'";
			}

			$query = "SELECT strasse, ort, plz FROM ".DB_PREFIX."mitglieder
						WHERE ".implode(' AND ',$where)." AND ausgetreten IS NULL";
			$_db->holeDaten($query);
			if($_db->ergebnis['anzahl'] == 0){
				$ausgabe .= '<daten id="ohnestrasse" anzahl="0" />'."\n";
			}
			else{
				$daten = array();
				foreach($_db->ergebnis['daten'] as $row){
					foreach($daten as $key2 => $row2){
						if($row['ort'] != $row2['ort'] or $row['plz'] != $row2['plz']){
							continue;
						}
						$daten[$key2]['anz']++;
						continue 2;
					}
					$row['anz'] = 1;
					$daten[] = $row;
				}
				usort($daten,'anzsort');
				$ausgabe .= '<daten id="ohnestrasse" anzahl="'.count($daten).'">'."\n";
				foreach($daten as $row){
					$ausgabe .= '  <datensatz anz="'.$row['anz'].'"';
					$ausgabe .= ' ort="'.text_format($row['ort'],'xml').'" plz="'.text_format($row['plz'],'xml').'" />'."\n";
				}
				$ausgabe .= '</daten>'."\n";
			}
		}
		else{
			$ausgabe .= '<daten id="ohnestrasse" anzahl="0" />'."\n";
		}

		# Daten mit Strasse
		$where = array();
		if(!empty($str)){
			$where[] = "strasse LIKE '".text_format($str,'db')."%'";
		}
		if(!empty($ort)){
			$where[] = "ort LIKE '".text_format($ort,'db')."%'";
		}
		if(!empty($plz)){
			$where[] = "plz LIKE '".text_format($plz,'db')."%'";
		}

		$query = "SELECT strasse, ort, plz FROM ".DB_PREFIX."mitglieder
					WHERE ".implode(' AND ',$where)." AND ausgetreten IS NULL";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] == 0){
			$ausgabe .= '<daten id="mitstrasse" anzahl="0" />'."\n";
		}
		else{
			$daten = array();
			foreach($_db->ergebnis['daten'] as $row){
				foreach($daten as $key2 => $row2){
					if($row['strasse'] != $row2['strasse'] or $row['ort'] != $row2['ort'] or $row['plz'] != $row2['plz']){
						continue;
					}
					$daten[$key2]['anz']++;
					continue 2;
				}
				$row['anz'] = 1;
				$daten[] = $row;
			}
			usort($daten,'strassensort');
			$ausgabe .= '<daten id="mitstrasse" anzahl="'.count($daten).'">'."\n";
			foreach($daten as $row){
				$ausgabe .= '  <datensatz anz="'.$row['anz'].'" str="'.text_format($row['strasse'],'xml').'"';
				$ausgabe .= ' ort="'.text_format($row['ort'],'xml').'" plz="'.text_format($row['plz'],'xml').'" />'."\n";
			}
			$ausgabe .= '</daten>'."\n";
		}
	}
	$ausgabe .= '</ergebnis>';
	header('Content-Type: text/xml');
	echo $ausgabe;
	break;

case 'familieanlegen':
	function ergebnismeldung($code, $optionen = array()){
		$statusmeldungen = array(
			1 => 'Die Familie %s wurde angelegt.',
			-1 => 'Dir fehlen die Rechte um Familien anlegen zu dürfen.',
			-2 => 'Die Familie %s existiert bereits.',
			-3 => 'Es wurde kein Familientitel angegeben.',
			-4 => 'Der Schreibschutz für alle Daten ist gesetzt, es können momentan keine Daten verändert werden.'
		);
		if(in_array($code, array(1,-2))){
			$meldung = sprintf($statusmeldungen[$code], $optionen['familie']);
		}
		else{
			$meldung = $statusmeldungen[$code];
		}
		if($code > 0){
			dbgeaendert();
		}
		$ausgabe = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
		$ausgabe .= '<ergebnis>'."\n";
		$ausgabe .= ' <code>'.$code.'</code>'."\n";
		$ausgabe .= ' <meldung>'.text_format($meldung,'xml').'</meldung>'."\n";
		if(isset($optionen['vorhandeneid'])){
			$ausgabe .= ' <vorhandene>'.$optionen['vorhandeneid'].'</vorhandene>'."\n";
		}
		if(isset($optionen['daten'])){
			$ausgabe .= ' <daten>'."\n";
			$ausgabe .= '  <option value="-">[keine]</option>'."\n";
			foreach($optionen['daten'] as $id => $titel){
				$ausgabe .= '  <option value="'.$id.'"';
				if($id == $optionen['insertid']){
					$ausgabe .= ' selected="selected"';
				}
				$ausgabe .=  '>'.$titel.'</option>'."\n";
			}
			$ausgabe .= ' </daten>'."\n";
		}
		$ausgabe .= '</ergebnis>'."\n";
		header('Content-Type: text/xml');
		echo $ausgabe;
		exit;
	}

	if(!pruefeRechte('m_familien_bearbeiten')){
		ergebnismeldung(-1);
	}
	elseif(!isset($_POST['familientitel']) or empty($_POST['familientitel'])){
		ergebnismeldung(-3);
	}
	elseif(TKSWIM_SCHREIBSCHUTZ){
		ergebnismeldung(-4);
	}
	else{
		$optionen = array();
		$optionen['familie'] = $_POST['familientitel'];
		$query = "SELECT id, titel FROM ".DB_PREFIX."familien WHERE titel = '".text_format($_POST['familientitel'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl()>0){
			$optionen['vorhandeneid'] = $_db->holeWert('id');
			ergebnismeldung(-2, $optionen);
		}
		else{
			$query = "INSERT INTO ".DB_PREFIX."familien SET titel = '".text_format($_POST['familientitel'],'db')."'";
			$_db->fuehreQueryAus($query);
			$optionen['insertid'] = $_db->ergebnis['insertid'];
			$query = "SELECT id, titel FROM ".DB_PREFIX."familien ORDER BY titel";
			$_db->holeDaten($query);
			$optionen['daten'] = $_db->baueArray('titel','id');
			ergebnismeldung(1, $optionen);
		}
	}

default:
	exit;
}
exit;
# EOF
