<?php
require_once('../__inc/_start.inc.php');
$_seite = 71;
$erlaubt = pruefeRechte('e_vereinsrekorde');
$_tmpl->assign('ueberschrift','Export - Vereinsrekorde');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

if(!defined('BR')){
	define('BR',PHP_EOL);
}

$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'pflichtzeiten':
	$_id = 1;

	if(!in_array($_GET['ziellaenge'], ['50','100','200'])){
		$_tmpl->assign('fehler', 'Die Ziellänge ist ungültig');
		break;
	}

	$query = "SELECT bezeichnung FROM ".DB_PREFIX."pflichtzeiten WHERE id = '".text_format($_GET['datensatz'],'db')."'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() != 1){
		$_tmpl->assign('fehler', 'Der Pflichtzeitdatensatz existiert nicht');
		break;
	}

	$daten = [];
	$daten['bezeichnung'] = $_db->holeWert();
	# Jahrgaenge holen
	$query = "SELECT id, jahrgang, pos 
				FROM ".DB_PREFIX."pflichtzeiten_jahrgaenge WHERE pflichtzeitenid = ".$_GET['datensatz']." ORDER BY pos";
	$_db->holeDaten($query);
	$daten['undaelter'] = false;
	$daten['jahrgaenge'] = $_db->baueArray('jahrgang','id');
	foreach($daten['jahrgaenge'] as $jid => $jg){
		if(substr($jg,-1) == '+'){
			$daten['undaelter'] = $jg;
		}
		$daten['jahrgaenge'][$jid] = (int)$jg;
	}
	
	# Strecken holen
	$query = "SELECT id, disziplin as lage, laenge, mw
				FROM ".DB_PREFIX."pflichtzeiten_strecken
				WHERE pflichtzeitenid = ".$_id." ORDER BY disziplin, laenge, mw";
	$_db->holeDaten($query);
	$daten['strecken'] = $_db->baueArray('*','id');
	$daten['_zeiten'] = [
		'm' => [],
		'w' => []
	];
	foreach($daten['jahrgaenge'] as $jahrgang){
		$daten['_zeiten']['m'][$jahrgang] = [];
		$daten['_zeiten']['w'][$jahrgang] = [];
		foreach($daten['strecken'] as $strecke){
			$daten['_zeiten'][$strecke['mw']][$jahrgang][$strecke['lage']][$strecke['laenge']] = '';
		}
	}
	
	# Zeiten holen
	$query = "SELECT streckenid, jahrgangid, zeit FROM ".DB_PREFIX."pflichtzeiten_zeiten
				WHERE streckenid IN (".implode(', ',array_keys($daten['strecken'])).") AND
				jahrgangid IN (".implode(', ',array_keys($daten['jahrgaenge'])).")";
	$_db->holeDaten($query);
	if($_db->ergebnis['anzahl'] > 0){
		foreach($_db->ergebnis['daten'] as $row){
			$lage = $daten['strecken'][$row['streckenid']]['lage'];
			$mw = $daten['strecken'][$row['streckenid']]['mw'];
			$laenge = $daten['strecken'][$row['streckenid']]['laenge'];
			$jahrgang = $daten['jahrgaenge'][$row['jahrgangid']];
			$daten['_zeiten'][$mw][$jahrgang][$lage][$laenge] = $row['zeit'];
		}
	}

	# Pflichtzeit für die Ziellänge auswählen
	#  (für Ziellänge=50m wird erst nach einer 100m-Zeit gesucht usw.)
	$quellstrecken = [
		'50' => [100,25,200],
		'100' => [50,200,25,400],
		'200' => [100,400,50,800]
	];
	$daten['_qualizeiten'] = [];
	foreach($daten['_zeiten'] as $mw => $alter){
		foreach($alter as $jahrgang => $disziplinen){
			foreach($disziplinen as $lage => $strecken){
				if($_GET['ziellaenge'] == 50 and $lage == 5){
					continue;
				}
				if(isset($strecken[$_GET['ziellaenge']]) and !empty($strecken[$_GET['ziellaenge']])){
					$daten['_qualizeiten'][$mw][$jahrgang][$lage] = $strecken[$_GET['ziellaenge']];
					continue;
				}
				# Quellstrecke wählen
				$quellstrecke = false;
				foreach($quellstrecken[$_GET['ziellaenge']] as $quelle){
					if(isset($strecken[$quelle]) and !empty($strecken[$quelle])){
						$quellstrecke = $quelle;
					}
				}
				if($quellstrecke === false){
					continue;
				}
				$q = $_GET['ziellaenge']/$quellstrecke;
				$hochrunter = $q<1?'runter':'hoch';
				$faktor = $_gleinst['wettkaempfe_abwickeln']['interplationsfaktor'.$hochrunter];
				$faktor = pow($faktor,abs(log($q,2)))*$q;
				$zeit = round($faktor*$strecken[$quellstrecke]);
				$daten['_qualizeiten'][$mw][$jahrgang][$lage] = $zeit;
			}
		}
	}

	$_lagen_en = array(
		1 => 'FREE',
		2 => 'BREAST',
		3 => 'BACK',
		4 => 'FLY',
		5 => 'MEDLEY'
	);

	$inhalt = '<?xml version="1.0" encoding="UTF-8"?>'.BR;
	$inhalt .= '<LENEX version="3.0">'.BR;
	$inhalt .= ' <CONSTRUCTOR name="tkswim" version="'.TKSWIM_VERSION.'">'.BR;
	$inhalt .= '  <CONTACT name="Tobias Kloth" country="GER" email="" internet="https://tkswim.de/" />'.BR;
	$inhalt .= ' </CONSTRUCTOR>'.BR;
	$inhalt .= ' <RECORDLISTS>'.BR;
	foreach($daten['_qualizeiten'] as $mw => $jahrgaenge){
		foreach($jahrgaenge as $jahrgang => $disziplinen){
			$inhalt .= '  <RECORDLIST course="OPEN" gender="M" name="Qualizeiten '.text_format($daten['bezeichnung'],'xml').'">'.BR;
			$maxalter = $daten['undaelter']==$jahrgang?'-1':$jahrgang;
			$inhalt .= '   <AGEGROUP agemin="'.$jahrgang.'" agemax="'.$maxalter.'" />'.BR;
			$inhalt .= '   <RECORDS>'.BR;
			foreach($disziplinen as $lage => $zeit){
				$inhalt .= '    <RECORD swimtime="00:'.text_format($zeit, 'schwimmzeit').'">'.BR;
				$inhalt .= '     <SWIMSTYLE relaycount="1" distance="'.text_format($_GET['ziellaenge'],'xml').'" stroke="'.$_lagen_en[$lage].'" />'.BR;
				$inhalt .= '    </RECORD>'.BR;
			}
			$inhalt .= '   </RECORDS>'.BR;
			$inhalt .= '  </RECORDLIST>'.BR;
		}
	}
	$inhalt .= ' </RECORDLISTS>'.BR;
	$inhalt .= '</LENEX>'.BR;

	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($inhalt, 'qualizeiten_'.$_GET['ziellaenge'].'.lef');
	$zipinh = $zip->gebeDateiAus('qualizeiten_'.$_GET['ziellaenge'].'.lxf', 'application/x-lenexdatei');
	
	
case 'vjr':
	$query = "SELECT z.id as zid, m.vorname, m.nachname, m.mw, CONCAT(YEAR(m.gebdatum),'-01-01') as mdatum, m.dsvid,
				  z.zeit, z.streckenlaenge, z.disziplin, w.ort, w.titel, DATE_FORMAT(z.datum, '%Y-%m-%d') as zdatum,
				  IF(YEAR(z.datum)-YEAR(gebdatum)>=20,CONCAT('ak',FLOOR((YEAR(z.datum)-YEAR(gebdatum))/5)*5),YEAR(z.datum)-YEAR(gebdatum)) as ak,
				  IF(YEAR(z.datum)-YEAR(gebdatum)>=20,FLOOR((YEAR(z.datum)-YEAR(gebdatum))/5)*5,YEAR(z.datum)-YEAR(gebdatum)) as sortak
				FROM ((".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id)
				  LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id)
				  LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid=w.id
				WHERE zr.art='aVJR' ORDER BY sortak, disziplin, streckenlaenge";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()<1){
		$_tmpl->assign('fehler','Es wurden keine Vereinsjahrgangsrekorde gefunden');
		break;
	}
	$zeiten = $_db->baueArray('*','#');

	$_lagen_en = array(
		1 => 'FREE',
		2 => 'BREAST',
		3 => 'BACK',
		4 => 'FLY',
		5 => 'MEDLEY'
	);

	$vjr = array();
	$neuesterrekord = array();
	foreach($zeiten as $row){
		if(!isset($vjr[$row['ak']])){
			$vjr[$row['ak']] = array('m'=>'','w'=>'');
			$neuesterrekord[$row['ak']] = array('m'=>'0000-00-00','w'=>'0000-00-00');
		}
		if($row['zdatum'] > $neuesterrekord[$row['ak']][$row['mw']]){
			$neuesterrekord[$row['ak']][$row['mw']] = $row['zdatum'];
		}
		$nation = $row['ort']=='Riccione'?'ITA':'GER';
		$vjr[$row['ak']][$row['mw']] .= '    <RECORD swimtime="00:'.text_format($row['zeit'],'schwimmzeit').'">'.BR;
		$vjr[$row['ak']][$row['mw']] .= '     <SWIMSTYLE relaycount="1" distance="'.$row['streckenlaenge'].'" stroke="'.$_lagen_en[$row['disziplin']].'" />'.BR;
		$vjr[$row['ak']][$row['mw']] .= '     <MEETINFO city="'.text_format($row['ort'],'xml').'" date="'.$row['zdatum'].'" name="'.text_format($row['titel'],'xml').'" nation="'.$nation.'" />'.BR;
		$vjr[$row['ak']][$row['mw']] .= '     <ATHLETE birthdate="'.$row['mdatum'].'" firstname="'.text_format($row['vorname'], 'xml').'" gender="'.($row['mw']=='m'?'M':'F').'" lastname="'.text_format($row['nachname'], 'xml').'"'.(!is_null($row['dsvid'])?' passport="'.$row['dsvid'].'"':'').' />'.BR;
		$vjr[$row['ak']][$row['mw']] .= '    </RECORD>'.BR;
	}

	$inhalt = '<?xml version="1.0" encoding="UTF-8"?>'.BR;
	$inhalt .= '<LENEX version="2.0">'.BR;
	$inhalt .= ' <CONSTRUCTOR name="tkswim" version="'.TKSWIM_VERSION.'">'.BR;
	$inhalt .= '  <CONTACT name="Tobias Kloth" country="GER" email="" internet="https://tkswim.de/" />'.BR;
	$inhalt .= ' </CONSTRUCTOR>'.BR;
	$inhalt .= ' <RECORDLISTS>'.BR;
	foreach($vjr as $ak => $rekorde){
		$name = '';
		if(substr($ak,0,2) == 'ak'){
			$name = strtoupper($ak);
			if($ak == 'ak95'){
				$minalter = 95;
				$maxalter = -1;
			}
			else{
				list($minalter,,,,$maxalter) = explode(',',$_altersklassen[$ak]);
			}
		}
		else{
			$minalter = $maxalter = $ak;
		}
		$inhalt .= '  <RECORDLIST course="OPEN" gender="M" name="Vereinsjahrgangsrekorde" updated="'.$neuesterrekord[$ak]['m'].'">'.BR;
		$inhalt .= '   <AGEGROUP agemin="'.$minalter.'" agemax="'.$maxalter.'"'.(!empty($name)?' name="'.$name.'"':'').' />'.BR;
		$inhalt .= '   <RECORDS>'.BR;
		$inhalt .= $rekorde['m'];
		$inhalt .= '   </RECORDS>'.BR;
		$inhalt .= '  </RECORDLIST>'.BR;
		$inhalt .= '  <RECORDLIST course="OPEN" gender="F" name="Vereinsjahrgangsrekorde" updated="'.$neuesterrekord[$ak]['w'].'">'.BR;
		$inhalt .= '   <AGEGROUP agemin="'.$minalter.'" agemax="'.$maxalter.'"'.(!empty($name)?' name="'.$name.'"':'').' />'.BR;
		$inhalt .= '   <RECORDS>'.BR;
		$inhalt .= $rekorde['w'];
		$inhalt .= '   </RECORDS>'.BR;
		$inhalt .= '  </RECORDLIST>'.BR;
	}
	$inhalt .= ' </RECORDLISTS>'.BR;
	$inhalt .= '</LENEX>'.BR;

	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($inhalt, 'vereinsjahrgangsrekorde.lef');
	$zipinh = $zip->gebeDateiAus('vereinsjahrgangsrekorde.lxf', 'application/x-lenexdatei');

case 'vr':
	$query = "SELECT z.id as zid, m.vorname, m.nachname, m.mw, CONCAT(YEAR(m.gebdatum),'-01-01') as mdatum, m.dsvid,
				  z.zeit, z.streckenlaenge, z.disziplin, w.ort, w.titel, DATE_FORMAT(z.datum, '%Y-%m-%d') as zdatum
				FROM ((".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id)
				  LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id)
				  LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid=w.id
				WHERE zr.art='aVR' ORDER BY disziplin, streckenlaenge";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()<1){
		$_tmpl->assign('fehler','Es wurden keine Vereinsrekorde gefunden');
		break;
	}
	$zeiten = $_db->baueArray('*','zid');
	$_lagen_en = array(
		1 => 'FREE',
		2 => 'BREAST',
		3 => 'BACK',
		4 => 'FLY',
		5 => 'MEDLEY'
	);
	$inhalt = '<?xml version="1.0" encoding="UTF-8"?>'.BR;
	$inhalt .= '<LENEX version="2.0">'.BR;
	$inhalt .= ' <CONSTRUCTOR name="tkswim" version="'.TKSWIM_VERSION.'">'.BR;
	$inhalt .= '  <CONTACT name="Tobias Kloth" country="GER" email="" internet="https://tkswim.de/" />'.BR;
	$inhalt .= ' </CONSTRUCTOR>'.BR;
	$inhalt .= ' <RECORDLISTS>'.BR;
	$rekorde = array('m'=>'','w'=>'');
	$neuesterrekord = array('m'=>'0000-00-00','w'=>'0000-00-00');
	foreach($zeiten as $row){
		if($row['zdatum'] > $neuesterrekord[$row['mw']]){
			$neuesterrekord[$row['mw']] = $row['zdatum'];
		}
		$nation = $row['ort']=='Riccione'?'ITA':'GER';
		$rekorde[$row['mw']] .= '    <RECORD swimtime="00:'.text_format($row['zeit'],'schwimmzeit').'">'.BR;
		$rekorde[$row['mw']] .= '     <SWIMSTYLE relaycount="1" distance="'.$row['streckenlaenge'].'" stroke="'.$_lagen_en[$row['disziplin']].'" />'.BR;
		$rekorde[$row['mw']] .= '     <MEETINFO city="'.text_format($row['ort'], 'xml').'" date="'.$row['zdatum'].'" name="'.text_format($row['titel'], 'xml').'" nation="'.$nation.'" />'.BR;
		$rekorde[$row['mw']] .= '     <ATHLETE birthdate="'.$row['mdatum'].'" firstname="'.text_format($row['vorname'], 'xml').'" gender="'.($row['mw']=='m'?'M':'F').'" lastname="'.text_format($row['nachname'], 'xml').'"'.(!is_null($row['dsvid'])?' passport="'.$row['dsvid'].'"':'').' />'.BR;
		$rekorde[$row['mw']] .= '    </RECORD>'.BR;
	}
	/* VR - männlich */
	$inhalt .= '  <RECORDLIST course="OPEN" gender="M" name="Vereinsrekorde" updated="'.$neuesterrekord['m'].'">'.BR;
	$inhalt .= '   <RECORDS>'.BR;
	$inhalt .= $rekorde['m'];
	$inhalt .= '   </RECORDS>'.BR;
	$inhalt .= '  </RECORDLIST>'.BR;
	/* VR - weiblich */
	$inhalt .= '  <RECORDLIST course="OPEN" gender="F" name="Vereinsrekorde" updated="'.$neuesterrekord['w'].'">'.BR;
	$inhalt .= '   <RECORDS>'.BR;
	$inhalt .= $rekorde['w'];
	$inhalt .= '   </RECORDS>'.BR;
	$inhalt .= '  </RECORDLIST>'.BR;
	$inhalt .= ' </RECORDLISTS>'.BR;
	$inhalt .= '</LENEX>'.BR;

	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($inhalt, 'vereinsrekorde.lef', time());
	$zipinh = $zip->gebeDateiAus('vereinsrekorde.lxf', 'application/x-lenexdatei');
	exit;

default:
	$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."pflichtzeiten ORDER BY sort";
	$_db->holeDaten($query);
	$pflichtzeiten = $_db->baueArray('bezeichnung', 'id');
	$_tmpl->assign('pflichtzeiten', $pflichtzeiten);
	$_inh .= $_tmpl->fetch('export/71.vereinsrekorde.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
