<?php
require_once('../__inc/_start.inc.php');
$_seite = 33;
$erlaubt = pruefeRechte('tr_anwesenheitsliste');
$_tmpl->assign('ueberschrift','Anwesenheitslisten');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
require_once(PFAD_INCLUDE.'func/holegruppen.inc.php');
$gruppen = holeGruppen();
if(count($gruppen) < 1){
	$_tmpl->assign('fehler', 'Es wurden keine Trainingsgruppen gefunden');
}
else{
$_tmpl->assign('gruppen',$gruppen);
require_once(PFAD_INCLUDE.'func/wettkaempfe_leseabzuwickelndeein.inc.php');
wettkaempfe_leseAbzuwickelndeEin();
$_tmpl->assign('wettkaempfe',$_SESSION['user']['wkabwickeln']['wettkaempfe']);

$genauigkeiten = array(
	'sekunden'    => 'gerundet (auf Sekunden genau)',
	'zehntel'     => 'gerundet (auf Zehntel genau)',
	'hundertstel' => 'genaue Zeit (auf Hundertstel genau)'
);
$positionueberschrift = array(
	'links'  => 'links (Standard)',
	'mitte'  => 'mitte',
	'rechts' => 'rechts'
);
$_tmpl->assign('genauigkeiten',$genauigkeiten);
$_tmpl->assign('positionueberschrift',$positionueberschrift);

# Standardwerte
$standard = array(
	'von' => '',
	'bis' => '',
	'gruppen' => array(),
	'listenart' => 'normale',
	'az' => array('1_100','2_100','3_100','4_100'),
	'telefonnummern_n' => 1,
	'kaestchen' => 2,
	'positionueberschrift_n' => 'links'
);
  # Anfang- und Ende berechnen
$user_conf = $_einst['anwesenheitsliste'];
switch($user_conf['anfang']){
case 'woche':
	$tmp = time();
	while(date('w',$tmp) != 1){
		$tmp += 86400;
	}
	$timestamp_anfang = $tmp;
	break;
case 'monat':
	$timestamp_anfang = mktime(12,0,0,date('n')+1,1,(date('n')==12?date('Y')+1:date('Y')));
	break;
case 'ferien':
	$query = "SELECT UNIX_TIMESTAMP(ADDDATE(bis,INTERVAL 1 DAY)) as anfang
				FROM ".DB_PREFIX."ferien WHERE bis IS NOT NULL AND bis > NOW() ORDER BY bis ASC LIMIT 1";
	$_db->holeDaten($query);
	$timestamp_anfang = $_db->holeWert();
	break;
case 'vorgegeben':
	$query = "SELECT von, bis FROM ".DB_PREFIX."ferien
				WHERE art IN(10,1,13) AND
				((ADDDATE(von,INTERVAL 2 MONTH)>NOW() AND bis IS NULL) OR (ADDDATE(bis,INTERVAL 2 MONTH)>NOW() AND bis IS NOT NULL))
				ORDER BY von LIMIT 1";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() < 1){
		$timestamp_anfang = time();
	}
	else{
		$row = $_db->holeZeile();
		$datum = is_null($row['bis'])?$row['von']:$row['bis'];
		$timestamp_anfang = strtotime($datum);
		$query = "SELECT UNIX_TIMESTAMP(DATE_SUB(von, INTERVAL 1 DAY)) as bis FROM ".DB_PREFIX."ferien
					WHERE art IN(10,1,13) AND von > '".$datum."' ORDER BY von LIMIT 1";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() > 0){
			$timestamp_ende = $_db->holeWert();
		}
	}
	break;
case 'heute':
default:
	$timestamp_anfang = time();
	break;
}
$standard['von'] = date('d.m.Y',$timestamp_anfang);
$zeitraum = substr($user_conf['zeitraum'],-1);
if(isset($timestamp_ende)){
	$standard['bis'] = date('d.m.Y',$timestamp_ende);
}
else{
	$standard['bis'] = date('d.m.Y',strtotime($zeitraum.' month',$timestamp_anfang)-86400);
}
  # Trainingsgruppen vorbelegen
$query = "SELECT gruppenid FROM ".DB_PREFIX."gruppen_uebungsleiter WHERE uebungsleiterid = ".$_SESSION['user']['id'];
$_db->holeDaten($query);
$standard['gruppen'] = $_db->baueArray('gruppenid','#');
# Ende der Standardwerte

if(isset($_GET['gruppe'])){ # ein Link mit ?gruppe=1 gibt direkt eine PDF-Datei mit der Liste der Gruppe 1 aus
	$_POST['generieren'] = 1;
	$_POST['daten'] = $standard;
	$_POST['daten']['gruppen'] = array($_GET['gruppe']);
}


if(!isset($_POST['generieren'])){
	$_tmpl->assign('daten',$standard);
}
else{
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	$f = $d = '';
	if(!isset($_POST['daten']['gruppen'])){
		$f .= 'Es wurde keine Gruppe ausgewählt.<br />';
	}
	else{
		$anz = count($_POST['daten']['gruppen']);
		for($i=0;$i<$anz;$i++){
			$f .= pruefen($_POST['daten']['gruppen'][$i],'wertemenge','Die Gruppe ist ungültig',array_keys($gruppen));
		}
	}

	if(!in_array($_POST['daten']['listenart'],array('normale','wettkampfmeldung','blanko'))){
		$f .= 'Die Listenart ist ungültig<br />';
	}
	else{
		switch($_POST['daten']['listenart']){
		case 'normale':
			# Anfangs-/Enddatum prüfen
			$d .= pruefen($_POST['daten']['von'],'leer','Ab welchem Datum soll die Anwesenheitsliste generiert werden?');
			$d .= pruefen($_POST['daten']['von'],'datum','Das von-Datum ist ungültig.');
			$d .= pruefen($_POST['daten']['bis'],'leer','Bis zu welchem Datum soll die Anwesenheitsliste generiert werden?');
			$d .= pruefen($_POST['daten']['bis'],'datum','Das bis-Datum ist ungültig.');
			if(empty($d)){
				$f .= pruefen($_POST['daten']['von'],'datumvordatum','Das bis-Datum muss nach dem von-Datum liegen',$_POST['daten']['bis']);
			}
			else{
				$f .= $d;
			}
			# aktuelle Zeiten - erlaubte Strecken
			if(isset($_POST['daten']['aktuellezeiten'])){
				if(!isset($_POST['daten']['az']) or !is_array($_POST['daten']['az'])){
					$f .= 'Es wurden keine Strecken für die aktuellen Zeiten ausgewählt<br />';
				}
				else{
					$erlaubt = array(
						'1_50', '1_100', '1_200', '1_400', '1_800', '1_1500',
						'2_50', '2_100', '2_200',
						'3_50', '3_100', '3_200',
						'4_50', '4_100', '4_200',
						'5_100', '5_200', '5_400'
					);
					foreach($_POST['daten']['az'] as $strecke){
						$f .= pruefen($strecke, 'wertemenge', 'Die Strecke ist ungültig', $erlaubt);
					}
				}
				$f .= pruefen($_POST['daten']['genauigkeit'], 'wertemenge', 'Die Genauigkeit ist ungültig', array_keys($genauigkeiten));
				$f .= pruefen($_POST['daten']['positionueberschrift_n'], 'wertemenge', 'Die Position der Überschrift ist ungültig', array_keys($positionueberschrift));
			}
			break;
		case 'wettkampfmeldung':
			$f .= pruefen($_POST['daten']['wettkampf'],'wertemenge','Der gewählte Wettkampf ist ungültig.',array_keys($_SESSION['user']['wkabwickeln']['wettkaempfe']));
			break;
		case 'blanko':
			$f .= pruefen($_POST['daten']['kaestchen'],'zahl','Die Anzahl der Kästchen ist ungültig');
			$f .= pruefen($_POST['daten']['positionueberschrift_n'], 'wertemenge', 'Die Position der Überschrift ist ungültig', array_keys($positionueberschrift));
			break;
		default:
			break;
		}
	}

	if(!empty($f)){
		$_tmpl->assign('fehler',$f);
		$_tmpl->assign('daten',$_POST['daten']);
	}
	else{
		require_once(PFAD_INCLUDE.'func/erstelleanwesenheitsliste.inc.php');
		$gruppen = $_POST['daten']['gruppen'];
		$conf = array();
		switch($_POST['daten']['listenart']){
		case 'wettkampfmeldung':
			$conf['wettkampf'] = $_POST['daten']['wettkampf'];
			$conf['positionueberschrift'] = $_POST['daten']['positionueberschrift_n'];
			# ist de Wettkampf ein interner Wettkampf?
			$query = "SELECT wert FROM ".DB_PREFIX."eigenschaften 
						WHERE art = 'w' AND artid = ".$conf['wettkampf']." AND eigenschaft = 'wettkampfart'";
			$_db->holeDaten($query);
			$wkart = $_db->holeWert();
			$conf['lizenzinfos'] = ($wkart=='vm' or $wkart=='wrcup')?false:true;
			break;
		case 'blanko':
			$conf['kaestchen'] = $_POST['daten']['kaestchen'];
			$conf['telefon'] = isset($_POST['daten']['telefonnummern_b']);
			$conf['positionueberschrift'] = $_POST['daten']['positionueberschrift_b'];
			break;
		case 'normale':
			$conf['von'] = $_POST['daten']['von'];
			$conf['bis'] = $_POST['daten']['bis'];
			$conf['telefon'] = isset($_POST['daten']['telefonnummern_n']);
			$conf['positionueberschrift'] = $_POST['daten']['positionueberschrift_n'];
			if(isset($_POST['daten']['aktuellezeiten'])){
				$conf['aktuellezeiten'] = $_POST['daten']['az'];
				$conf['genauigkeit'] = $_POST['daten']['genauigkeit'];
				$conf['doppeltebreite'] = isset($_POST['daten']['doppeltebreite'])?1:0;
			}
			break;
		}
		erstelleAnwesenheitsliste($gruppen, $_POST['daten']['listenart'], $conf);
	}
}

$_tmpl->tk_javascriptzuweisen('inline',"function optionenzeigen(v){
  $('.optionen').hide(0);
  $('#'+$('input[name=daten[listenart]]:checked').val()).show(v);
}
function aktuellezeiten(){
  $('input[name=\"daten[aktuellezeiten]\"]').is(':checked')?$('#aktuellezeiten').show(0):$('#aktuellezeiten').hide(0);
}");
$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.ui,jquery.tkswim');
$_tmpl->tk_javascriptzuweisen('onready', "\$('.datumwahl').tkswim_datumwahl();");
$_tmpl->tk_javascriptzuweisen('onready', "optionenzeigen(0);");
$_tmpl->tk_javascriptzuweisen('onready', "aktuellezeiten();");

$_inh .= $_tmpl->fetch('training/34.anwesenheitsliste-formular.inc.html');
} # Ende Anzahl-Trainingsgruppen-else
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
